SystemOrganization addCategory: #Spec!
SystemOrganization addCategory: #'Spec-Examples'!
SystemOrganization addCategory: #'Spec-Tests'!
SystemOrganization addCategory: #'Spec-ChangeSorter'!

!Morph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/14/2011 16:32'!
addMorphWrapper: aMorphWrapper
	
	
	aMorphWrapper addIn: self.! !

PanelMorph subclass: #TabContainerMorph
	instanceVariableNames: 'container tab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!TabContainerMorph commentStamp: '<historical>' prior: 0!
A TabContainerMorph is a morph (which should be pluggable soon) which handle a first bar for tabs button and a container which is used to display the morph corresponding to the selected tab!

!TabContainerMorph class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/7/2012 10:14'!
example

	| tc testMorph model model2 model3 anotherMorph anotherMorph2 associations classes |
	
	model := ClassMethodBrowser new.
	model2 := ClassMethodBrowser new.
	model3 := ClassMethodBrowser new.
	
	testMorph := model buildWithSpec: #internSpec.
	anotherMorph := model2 buildWithSpec: #internSpec.
	anotherMorph2 := model3 buildWithSpec: #internSpec.
	
	associations := {'Test' -> testMorph. 'Another'-> anotherMorph. 'Again' -> anotherMorph2}.
	tc := self withTabs: associations.
	classes := Smalltalk allClasses.
	model classes: classes .
	model2 classes: classes.
	model3 classes: classes.
	
	( tc embeddedInMorphicWindowLabeled: 'test') openInWorld.
	^ tc! !

!TabContainerMorph class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/7/2012 06:04'!
withTabs: associations

	^ self new
		addTabs: associations;
		yourself.! !

!TabContainerMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/7/2012 06:09'!
addAll
	
	self
		addMorph: tab
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ 35)).
				
	self
		addMorph: container
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 35 corner: 0 @ 0)).! !

!TabContainerMorph methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/7/2012 06:02'!
addTabs: associations

	associations do: [:each |
		self tab 
			addTab: (Text fromString: each key) 
			withAction: [ self setContent: each value ].
		container submorphs isEmpty ifTrue: [ container addMorph: each value ]]! !

!TabContainerMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/7/2012 06:08'!
container

	^ container! !

!TabContainerMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/7/2012 06:14'!
initialize
	"Initialization code for TabContainerMorph"

	super initialize.
	
	self changeProportionalLayout.
	container := PanelMorph new changeTableLayout; listDirection: #bottomToTop; color: Color white; yourself.
	
	tab := PluggableTabBarMorph on: self.
	tab width: 150.
	tab color: Color white darker darker.
	
	self addAll.! !

!TabContainerMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/9/2012 18:43'!
setContent: aMorph

	container removeAllMorphs.
	container addMorph: aMorph.
	aMorph color: Color white.
	aMorph takeKeyboardFocus.! !

!TabContainerMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/7/2012 06:08'!
tab

	^ tab! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 1/19/2012 18:04'!
getIndexSelector: aSelector

	getIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 2/9/2012 16:09'!
getSelectionListSelector: getListSel.

	getSelectionListSelector := getListSel! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 22:19'!
initialize

	super initialize.
	self initForKeystrokes.! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 1/19/2012 18:04'!
setIndexSelector: aSelector

	setIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 2/9/2012 16:14'!
setMultipleSelection: aBoolean

	multipleSelection := aBoolean! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 2/9/2012 16:09'!
setSelectionListSelector: getListSel.

	setSelectionListSelector := getListSel! !

Announcement subclass: #ValueChanged
	instanceVariableNames: 'newContents oldContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ValueChanged commentStamp: '<historical>' prior: 0!
A ValueChanged is an announcement raised when a value of a NewValueHolder is changed!

!ValueChanged class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:34'!
newContents: newContents

	^ self new
		newContents: newContents;
		yourself! !

!ValueChanged class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:26'!
oldContents: oldContent newContents: newContent

	^ self new
		newContents: newContent;
		oldContents: oldContent;
		yourself! !

!ValueChanged methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:27'!
newContents: anObject
	
	newContents := anObject! !

!ValueChanged methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:27'!
oldContents: anObject
	
	oldContents := anObject! !

AbstractTool subclass: #ChangeSorterModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-ChangeSorter'!

!ChangeSorterModel commentStamp: '<historical>' prior: 0!
A ChangeSorterModel is a model used by Change Sorter UIs for computation!

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:16'!
addPreambleTo: aChangeSet

	aChangeSet assurePreambleExists! !

!ChangeSorterModel methodsFor: 'environment' stamp: 'BenjaminVanRyseghem 2/4/2012 16:19'!
allChanges

	^ ChangeSet allChangeSets reverse! !

!ChangeSorterModel methodsFor: 'text' stamp: 'BenjaminVanRyseghem 2/4/2012 16:42'!
buildChangeSetDescriptionFor: changeSet
		
	^ changeSet
		ifNil: [ '' ] 
		ifNotNil: [ changeSet preambleString ifNil: ['']]! !

!ChangeSorterModel methodsFor: 'text' stamp: 'BenjaminVanRyseghem 2/4/2012 16:24'!
buildClassDescriptionFor: changeSet class: class
	| stream |

	stream := (String new: 100) writeStream.
		(changeSet classChangeAt: class name)
			do: [:each | 
				each = #remove
					ifTrue: [ stream nextPutAll: 'Entire class was removed.'; cr ].
				each = #addedThenRemoved
					ifTrue: [ stream nextPutAll: 'Class was added then removed.'; cr ].
				each = #rename
					ifTrue: [ stream nextPutAll: 'Class name was changed.'; cr ].
				each = #add
					ifTrue: [ stream nextPutAll: 'Class definition was added.'; cr ].
				each = #change
					ifTrue: [ stream nextPutAll: 'Class definition was changed.'; cr ].
				each = #reorganize
					ifTrue: [ stream nextPutAll: 'Class organization was changed.'; cr ].
				each = #comment 
					ifTrue: [ stream nextPutAll: 'New class comment.'; cr ]].
		^ stream contents! !

!ChangeSorterModel methodsFor: 'text' stamp: 'BenjaminVanRyseghem 2/4/2012 16:02'!
buildSelectorDescriptionFor: changeSet class: class selector: selector prettyPrint: prettyPrint showDiff: showDiff

	| changeType code |
	changeType := changeSet atSelector: selector class: class name.
	
	changeType == #remove
		ifTrue: [^ 'Method has been removed (see versions)'].
	changeType == #addedThenRemoved
		ifTrue: [^ 'Added then removed (see versions)']. 
	class
		ifNil: [^ 'Method was added, but cannot be found!!'].
	(class includesSelector: selector)
		ifFalse: [^ 'Method was added, but cannot be found!!'].
	code := class sourceCodeAt: selector.
	prettyPrint
		ifTrue: [ code := class prettyPrinterClass
							format: code
							in: class
							notifying: nil ].						
	showDiff
		ifTrue: [ code := self diffFromPriorSourceFor: code ].
		
	^ code asText makeSelectorBoldIn: class! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/5/2012 18:13'!
copyAllChangesFrom: source to: destination

	destination assimilateAllChangesFoundIn: source! !

!ChangeSorterModel methodsFor: 'class' stamp: 'BenjaminVanRyseghem 2/6/2012 03:42'!
copyClass: aClass from: source to: destination

	destination absorbClass: aClass name from: source.! !

!ChangeSorterModel methodsFor: 'message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:59'!
copySelector: selector inClass: class from: source to: destination

	destination
		absorbMethod: selector 
		class: class 
		from:source! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 17:33'!
createNewSet

	^ ChangeSet newChangeSet.! !

!ChangeSorterModel methodsFor: 'class' stamp: 'BenjaminVanRyseghem 2/6/2012 03:13'!
fileOutClass: aClass from: aChangeSet
	"this is a hack!!!! makes a new change set, called the class name, adds author initials to try to make a unique change set name, files it out and removes it. kfr 16 june 2000"
	"Method copied from ChangeSorter"
	| aSet |
	"File out the selected class set."
     aSet := ChangeSet newChangeSet: aClass name.
	aSet ifNil:[ ^self ].
	aSet absorbClass: aClass name from: aChangeSet.
	aSet fileOut.
	ChangeSet removeChangeSet: aSet.! !

!ChangeSorterModel methodsFor: 'message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:08'!
fileOutSelector: selector from: aClass
	
	aClass fileOutMethod: selector! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 20:03'!
findChangeSetIn: aCollectionOfChangeSets
	"Search for a changeSet by name.  Pop up a menu of all changeSets whose name contains the string entered by the user.  If only one matches, then the pop-up menu is bypassed"
	| index pattern candidates nameList |
	self okToChange ifFalse: [^ self].
	pattern := UIManager default request: 'ChangeSet name or fragment?'.
	pattern isEmptyOrNil ifTrue: [^ self].
	nameList := aCollectionOfChangeSets collect: #name.
	candidates := aCollectionOfChangeSets select:
			[:c | (nameList includes: c name) and: 
				[c name includesSubstring: pattern caseSensitive: false]].
	candidates size = 0 ifTrue: [ ^ Beeper beep ].
	candidates size = 1 ifTrue: [ ^ candidates first ].
	index := UIManager default chooseFrom: (candidates collect: [:each | each name]).
	index = 0 ifFalse: [ ^ (candidates at: index) ].! !

!ChangeSorterModel methodsFor: 'message' stamp: 'BenjaminVanRyseghem 2/7/2012 08:52'!
forgetSelector: selector inClass: aClass fromChangeSet: aChangeSet

	aChangeSet
			removeSelectorChanges: selector 
			class: aClass! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:32'!
removeChangeSet: aChangeSet prompting: doPrompt
	"Completely destroy my change set.  Check if it's OK first, and if doPrompt is true, get the user to confirm his intentions first."

	| message aName changeSetNumber msg |
	aName := aChangeSet name.
	aChangeSet okayToRemove ifFalse: [^ self]. "forms current changes for some project"
	(aChangeSet isEmpty or: [doPrompt not]) ifFalse:
		[message := 'Are you certain that you want to 
remove (destroy) the change set
named  "', aName, '" ?'.
		(self confirm: message) ifFalse: [^ self]].

	doPrompt ifTrue:
		[msg := aChangeSet hasPreamble
			ifTrue:
				[aChangeSet hasPostscript
					ifTrue:
						['a preamble and a postscript']
					ifFalse:
						['a preamble']]
			ifFalse:
				[aChangeSet hasPostscript
					ifTrue:
						['a postscript']
					ifFalse:
						['']].
		msg isEmpty ifFalse:
			[(self confirm: 
'Caution!!  This change set has
', msg, ' which will be
lost if you destroy the change set.
Do you really want to go ahead with this?') ifFalse: [^ self]]].

	"Go ahead and remove the change set"
	changeSetNumber := aChangeSet name initialIntegerOrNil.
	changeSetNumber ifNotNil: [SystemVersion current unregisterUpdate: changeSetNumber].
	ChangeSet removeChangeSet: aChangeSet.! !

!ChangeSorterModel methodsFor: 'class' stamp: 'BenjaminVanRyseghem 2/5/2012 22:57'!
removeClass: class from: changeSet

	changeSet removeClassChanges: class.! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:28'!
removePostscriptFrom: aChange

	(aChange hasPostscript and: [ aChange postscriptHasDependents ]) ifTrue:
		[^ self inform:
'Cannot remove the postscript right
now because there is at least one
window open on that postscript.
Close that window and try again.'].

	aChange removePostscript.! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 20:13'!
rename: aChangeSet
	"Store a new name string into the selected ChangeSet.  reject duplicate name; allow user to back out"

	| newName |
	newName := UIManager default request: 'New name for this change set'
						initialAnswer: aChangeSet name.
						
	(newName = aChangeSet name or: [newName isEmptyOrNil]) ifTrue:
			[ ^ Beeper beep ].

	(ChangeSet named: newName) ifNotNil:
			[ ^ UIManager default inform: 'Sorry that name is already used' ].

	aChangeSet name: newName.
	^ aChangeSet! !

!ChangeSorterModel methodsFor: 'text' stamp: 'BenjaminVanRyseghem 2/4/2012 16:03'!
setContentsOfChangeSet: changeSet forClass: class andSelector: selector prettyPrint: prettyPrint showDiff: showDiff 
	"return the source code that shows in the bottom pane"
	| strm changeType code |

	
	class
		ifNil: [
			"Only the change set is currently selected"
			^ self buildChangeSetDescriptionFor: changeSet ].
	selector isNil
		ifTrue: [ 
			"class is selected but not the selector"
			^ self buildClassDescriptionFor: changeSet class: class ]
		ifFalse: [
			"a class and a selector are selected"
			^ self buildSelectorDescriptionFor: changeSet class: class selector: selector prettyPrint: prettyPrint showDiff: showDiff ]! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 17:18'!
setCurrentChangeSet: aChangeSet

	ChangeSet newChanges: aChangeSet! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/5/2012 22:01'!
submerge: source into: destination
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	|   message |
	source == destination
		ifTrue: [ ^ false ].
	source isEmpty
		ifTrue: [ 
			self inform: 'Nothing to copy.  To remove,
simply choose "remove".'.
			^ false ].

	source okayToRemove ifFalse: [^ false].
	message := 'Please confirm:  copy all changes
in "', source name, '" into "', destination name, '"
and then destroy the change set
named "', source name, '"?'.
 
	(self confirm: message) ifFalse: [^ false].

	(source hasPreamble or: [source hasPostscript]) ifTrue:
		[(self confirm: 
'Caution!!  This change set has a preamble or
a postscript or both.  If you submerge it into
the other side, these will be lost.
Do you really want to go ahead with this?') ifFalse: [^ false]].

	self copyAllChangesFrom: source to: destination.
	self removeChangeSet: source prompting: false.
	^ true! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/5/2012 22:23'!
substractFrom: source to: destination

	source forgetAllChangesFoundIn: destination.! !

!Dictionary methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 2/9/2012 16:42'!
asValueHolder

	^ DictionaryValueHolder contents: self! !

!LayoutFrame methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 1/18/2012 01:57'!
fractions: fractionsOrNil offsets: offsetsOrNil

	| fractions offsets |

	fractions := fractionsOrNil ifNil: [0@0 extent: 0@0].
	offsets := offsetsOrNil ifNil: [0@0 extent: 0@0].
	
	^self
		topFraction: fractions top offset: offsets top;
		leftFraction: fractions left offset: offsets left;
		bottomFraction: fractions bottom offset: offsets bottom;
		rightFraction: fractions right offset: offsets right
! !

TestCase subclass: #SpecInterpreterTest
	instanceVariableNames: 'specInterpreter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!SpecInterpreterTest commentStamp: '<historical>' prior: 0!
A SpecInterpreterTest is a test class for testing the behavior of SpecInterpreter!

!SpecInterpreterTest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/19/2012 16:28'!
setUp
	"Setting up code for SpecInterpreterTest"


	specInterpreter := SpecInterpreter new.! !

!SpecInterpreterTest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/19/2012 15:57'!
tearDown
	"Tearing down code for SpecInterpreterTest"


	specInterpreter := nil.! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 17:34'!
testBuildMorphFor

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildMorphFor: model.
	
	self assert: (morph model == model).
	self assert: (model morph class = PluggableListMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 17:35'!
testBuildMorphForWithSpec

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildMorphFor: model withSpec: #testingSpec.
	
	self assert: (morph model == model).
	self assert: (model morph class = PluggableTextMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 17:40'!
testBuildWindowFor

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildWindowFor: model.
	
	self assert: ( model morph = morph).
	self assert: (morph submorphs anySatisfy: [:e | e class = PluggableListMorph ])! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 16:34'!
testConvertRandomSymbolOfClassToInstance
	
	| symbol instance |
	symbol := #PluggableListMorph.
	
	instance := specInterpreter convertSymbolOfClassToInstance: symbol.
	self assert: (instance class name = symbol)! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
testConvertSymbolOfClassToInstance
	
	| association instance|
	association := specInterpreter bindings associations first.
	
	instance := specInterpreter convertSymbolOfClassToInstance: association key.
	self assert: (instance class name = association value)! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 16:03'!
testInterpretASpecModel

	| spec model morph |
	model := ComposableModel new.
	spec := {#PluggableListMorph. #model:. #model}.
	morph := specInterpreter interpretASpec: spec model: model.
	
	self assert: (morph model == model).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 16:28'!
testInterpretASpecModelMorphAssociation

	| spec model morph |
	model := ComposableModel new.
	spec := {#PluggableListMorph. #model:. #model}.
	morph := specInterpreter interpretASpec: spec model: model.
	
	self assert: (model morph == morph).! !

Object subclass: #ComposableModel
	instanceVariableNames: 'morph focusOrder owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ComposableModel commentStamp: '<historical>' prior: 0!
ComposableModel is an abstract which represent a applicative model made to be composed with other ComposableModel!

ComposableModel subclass: #ButtonModel
	instanceVariableNames: 'actionHolder labelHolder stateHolder enabledHolder actionPerformedHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ButtonModel commentStamp: '<historical>' prior: 0!
A ButtonComposableModel is an applicative model which handle a basic button.

| b |
b:= ButtonComposableModel new.
b openWithSpec.
b labelHolder contents: 'Click me'.

self example!

!ButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/1/2012 13:44'!
internSpec

	^ {#PluggableButtonMorph.
	    		#on:getState:action:label:menu:. 	#model. #state. #action. #label. #nil.
			#getEnabledSelector:. 				#enabled.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!ButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/15/2011 14:42'!
title

	^ 'Button'! !

!ButtonModel methodsFor: 'morphic' stamp: 'SimonAllier 1/27/2012 11:42'!
action

	self morph ifNotNil: [:m | m takeKeyboardFocus ].
	self actionHolder contents value.
	" Here I set a dummy value just to make the holder raise an event "
	self actionPerformedHolder contents: nil.! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 01:33'!
action: aBlock

	self actionHolder contents: aBlock! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
actionHolder

	^ actionHolder! !

!ButtonModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 11:40'!
actionPerformedHolder
" I am a dummy holder used to announce that my action has been performed "
	^ actionPerformedHolder! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/15/2011 14:48'!
enabled

	^ self enabledHolder contents! !

!ButtonModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 11:47'!
enabled: aBoolean
	
	^ self enabledHolder contents: aBoolean! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:47'!
enabledHolder

	^ enabledHolder! !

!ButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:53'!
eventStringForNextFocus

	^ '<right>'! !

!ButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:54'!
eventStringForPreviousFocus

	^ '<left>'! !

!ButtonModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 10:17'!
initialize
	"Initialization code for ButtonComposableModel"

	super initialize.

	actionHolder := [] asValueHolder.
	labelHolder := '' asValueHolder.
	stateHolder := true asValueHolder.
	enabledHolder := true asValueHolder.

	actionPerformedHolder := nil asValueHolder! !

!ButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/23/2012 19:03'!
keyStroke: anEvent fromMorph: aMorph

	anEvent keyString = '<space>'
		ifTrue: [ self action ].
		
	super keyStroke: anEvent fromMorph: aMorph! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/15/2011 14:28'!
label

	^ self labelHolder contents! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 00:33'!
label: aString

	self labelHolder contents: aString! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
labelHolder

	^ labelHolder! !

!ButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/15/2011 14:10'!
state

	^ self stateHolder contents! !

!ButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 00:59'!
state: aBoolean
	
	^ self stateHolder contents: aBoolean! !

!ButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
stateHolder

	^ stateHolder! !

!ButtonModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 11:41'!
whenActionPerformedDo: aBlock

	self actionPerformedHolder whenChangedDo: aBlock! !

ComposableModel subclass: #ChangeSorterApplication
	instanceVariableNames: 'model changesListModel classesListModel methodsListModel textModel prettyPrint showDiff title window prettyButton diffButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-ChangeSorter'!

!ChangeSorterApplication commentStamp: '<historical>' prior: 0!
A ChangeSorterApplication is spec version of the dual sorter!

!ChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 15:25'!
internSpec

	^ {#Panel.
			#changeTableLayout.
			#listDirection:. 		#bottomToTop.
			#addMorph:.			self topSpec.
			#addMorph:. 		{	#model. 	#methodsListModel.	#internSpec	}.
			#addMorph:. 		{	#model. 	#textModel.	#internSpec	}.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill								}! !

!ChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 15:25'!
topSpec

	^ {#Panel.
			#changeTableLayout.
			#listDirection:. 		#rightToLeft.
			#addMorph:. 		{	#model. 	#changesListModel.	#internSpec	}.
			#addMorph:. 		{	#model. 	#classesListModel.	#internSpec	}.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill								}! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:19'!
addPreamble

	self model addPreambleTo: self selectedChangeSet.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 21:16'!
browseChangeSet
	"Open a message list browser on methods in the current change set"

	| messages |
	messages := self selectedChangeSet changedMessageList select: [ :each | each isValid].	
	Smalltalk tools  messageList
		openMessageList: messages 
		name: 'Methods in Change Set ', self selectedChangeSet name 
		autoSelect: ''! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:27'!
browseImplementorsOfMessages

	self model browseMessagesFrom: self selectedSelector! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/6/2012 03:03'!
browseMethodFull
	"Create and schedule a full Browser and then select the current class and message."

	self selectedClass ifNotNil:
		[:myClass | Smalltalk tools browser fullOnClass: myClass selector: self selectedSelector ]! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:10'!
browseSendersOfMessages

	self model browseSendersOfMessagesFrom: self selectedSelector! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:35'!
browseVersions
	"Create and schedule a changelist browser on the versions of the 
	selected message."
	
	self selectedClass ifNotNil: [:class |
		self selectedSelector ifNotNil: [:selector || method |
			method := class methodDict 
								at: selector 
								ifAbsent: [ ^ self inform: 'Sorry, only actual methods have retrievable versions.' ].
			self model browseVersionsFrom: method ]]! !

!ChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 10:47'!
changeSetMenu1: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	
	aMenu 
		title: 'Change Set';
		target: self.
		
	self selectedChangeSet
		ifNotNil:[
			aMenu
				add: 'Make changes go to me (m)'
				action: #setCurrentChangeSet;
				addLine;
				add: 'New change set... (n)'
				action: #newSet ].
	aMenu
		add: 'Find...(f)' 
		action: #findChangeSet.

	self selectedChangeSet
		ifNotNil:[
			aMenu
				addLine;
				add: 'Rename change set (r)'
				action: #rename;
				add: 'File out (o)'
				action: #fileOut;
				add: 'Browse methods (b)' 
				action: #browseChangeSet;
				add: 'Browse change set (B)'
				action: #openChangeSetBrowser;
				addLine ]! !

!ChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 10:50'!
changeSetMenu2: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	| cs |
	
	cs := self selectedChangeSet.
	self selectedChangeSet
		ifNotNil:[
			(cs notNil and: [ cs hasPreamble ])
				ifTrue: [
							aMenu add: 'Edit preamble (p)' action: #addPreamble.
							aMenu add: 'Remove preamble' action: #removePreamble	]
				ifFalse: [	aMenu add: 'Add preamble (p)' action: #addPreamble			].
			(cs notNil and: [ cs hasPostscript ])
				ifTrue: [	
							aMenu add: 'Edit postscript...' action: #editPostscript.
							aMenu add: 'Remove postscript' action: #removePostscript	]
				ifFalse: [	aMenu add: 'Add postscript...' action: #editPostscript			].

			aMenu addLine.

			aMenu add: 'Destroy change set (x)' action: #remove ].! !

!ChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/4/2012 22:15'!
changeSetMenu: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	
	isShifted ifTrue: [^ self shiftedChangeSetMenu: aMenu].
	self changeSetMenu1: aMenu shifted: isShifted.
	self changeSetMenu2: aMenu shifted: isShifted.
	
	^ aMenu! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/7/2012 11:23'!
changeSetShortcuts: event from: aMorph

	self selectedChangeSet
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseChangeSet ].
			event keyString = '<Cmd-B>' 		ifTrue: [ ^ self openChangeSetBrowser ].
			event keyString = '<Cmd-m>' 	ifTrue: [ ^ self setCurrentChangeSet ].
			event keyString = '<Cmd-n>' 		ifTrue: [ ^ self newSet ].
			event keyString = '<Cmd-o>' 		ifTrue: [ ^ self fileOut ].
			event keyString = '<Cmd-r>' 		ifTrue: [ ^ self rename ].
			event keyString = '<Cmd-p>' 		ifTrue: [ ^ self addPreamble ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self remove ]].
			
	event keyString = '<Cmd-f>' 				ifTrue: [ ^ self findChangeSet ].
		! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 20:03'!
changeSets

	^ self changesListModel getList! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 15:25'!
changesListModel

	^ changesListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/6/2012 03:25'!
changesMenu: aBlock

	changesListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 11:27'!
changesShortcuts: aBlock

	changesListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 11:30'!
classMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	self selectedClass ifNil: [ ^ nil ].
	aMenu title: 'Class list'.

	aMenu target: self.
	aMenu addList: #(
			-
			('Delete class from change set (d)'		forgetClass)
			('Remove class from system (x)'		removeClass)
			-
			('Browse full (b)'						browseMethodFull)
			-
			('FileOut'								fileOutClass)).

	^ aMenu! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/7/2012 11:31'!
classShortcuts: event from: aMorph

	self selectedClass
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseMethodFull ].
			event keyString = '<Cmd-d>' 		ifTrue: [ ^ self forgetClass ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self removeClass ]].! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 15:26'!
classesListModel

	^ classesListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/6/2012 03:25'!
classesMenu: aBlock

	classesListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 11:29'!
classesShortcuts: aBlock

	classesListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 16:08'!
currentText

	 ^ textModel getText! !

!ChangeSorterApplication methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/4/2012 16:46'!
defaultTitle
	
	^  'Change Sorter'! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:23'!
editPostscript
	
	self selectedChangeSet editPostscript! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 20:09'!
fileOut

	self selectedChangeSet fileOut! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/6/2012 03:11'!
fileOutClass

	self model fileOutClass: self selectedClass from: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:09'!
fileOutMessage
	"Put a description of the selected message on a file"

	self selectedSelector ifNotNil: [:selector |
		Cursor write showWhile:
			[ self model fileOutSelector: selector from: self selectedClass ]]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 20:00'!
findChangeSet

	| set |
	set := self model findChangeSetIn: self changeSets.
	changesListModel setSelectedItem: set.! !

!ChangeSorterApplication methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/5/2012 16:59'!
forceChangesListRefresh
	| sel |
	
	sel := self selectedChangeSet.
	changesListModel items: self model allChanges.
	changesListModel setSelectedItem: sel.! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/5/2012 22:56'!
forgetClass
	"Remove all mention of this class from the changeSet"

	self okToChange ifFalse: [^ self].
	self selectedClass ifNotNil: [:class |
		self model removeClass: class from: self selectedChangeSet.
		self setSelectedChangeSet: self selectedChangeSet ].
! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 10:08'!
forgetMessage

	self okToChange ifFalse: [^ self].
	self selectedSelector ifNotNil: [:selector | 
		self model 
			forgetSelector: selector 
			inClass: self selectedClass 
			fromChangeSet: self selectedChangeSet.
		self updateClassesList.
		self setSelectedClassIndex: self selectedClassIndex ]! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:38'!
initialize
	"Initialization code for ChangeSorterApplication"

	super initialize.

	self instantiateWidgets.
	self setFocus.
	
	prettyPrint := false.
	showDiff := false.
	
	model := ChangeSorterModel new.
	title := self defaultTitle.
	
	changesListModel wrappingBlock: [:item | item name ].
	changesListModel items: self model allChanges.
	
	self registerChangeActions.
	self registerClassActions.
	self registerSelectorActions.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:36'!
instantiateChangeSetModel
	
	changesListModel := self instantiate: ListComposableModel.
	changesListModel menu: [:aMenu :shifted | self changeSetMenu: aMenu shifted: shifted  ].
	changesListModel shortcuts: [:event :source | self changeSetShortcuts: event from: source ].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:36'!
instantiateClassModel
	
	classesListModel := self instantiate: ListComposableModel.
	classesListModel menu: [:aMenu :shifted | self classMenu: aMenu shifted: shifted ].
	classesListModel shortcuts: [:event :source | self classShortcuts: event from: source ].
	! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:37'!
instantiateMethodModel

	methodsListModel := self instantiate: ListComposableModel.
	methodsListModel menu: [:menu :shifted | self messageMenu: menu shifted: shifted ].
	methodsListModel shortcuts: [:event :source | self methodShortcuts: event from: source ].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:50'!
instantiateRadioButtons

	prettyButton := self instantiate: CheckBoxModel.
	diffButton := self instantiate: CheckBoxModel.
	
	prettyButton activationAction: [ 
		prettyPrint := true.
		self updateTextContents ].
	prettyButton desactivationAction: [ 
		prettyPrint := false.
		self updateTextContents  ].
	diffButton activationAction: [ 
		showDiff := true.
		self updateTextContents ].
	diffButton desactivationAction: [ 
		showDiff := false.
		self updateTextContents  ].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:37'!
instantiateTextModel

	textModel := self instantiate: TextModel.
	textModel aboutToStyle: true.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:45'!
instantiateWidgets
	
	self instantiateChangeSetModel.
	self instantiateClassModel.
	self instantiateMethodModel.
	self instantiateTextModel.
	
	self instantiateRadioButtons! !

!ChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 11:30'!
messageMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	self selectedSelector ifNil: [ ^ nil ].	
	aMenu title: 'Message list'.
	aMenu target: self.

	aMenu addList: #(
			('Delete method from changeSet (d)'	forgetMessage)
			('Remove method from system (x)'		removeMessage)
				-
			('Browse full (b)'						browseMethodFull)
			-
			('FileOut'								fileOutMessage)
			-
			('Senders of... (n)'						browseSendersOfMessages)
			('Implementors of... (m)'				browseImplementorsOfMessages)
			('Versions (v)'							browseVersions)).
	^ aMenu
! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/7/2012 11:34'!
methodShortcuts: event from: aMorph

	self selectedSelector
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseMethodFull ].
			event keyString = '<Cmd-d>' 		ifTrue: [ ^ self forgetMessage ].
			event keyString = '<Cmd-m>' 	ifTrue: [ ^ self browseImplementorsOfMessages ].
			event keyString = '<Cmd-n>' 		ifTrue: [ ^ self browseSendersOfMessages ].
			event keyString = '<Cmd-v>' 		ifTrue: [ ^ self browseVersions ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self removeMessage ]].! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 15:26'!
methodsListModel

	^ methodsListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 09:39'!
methodsMenu: aBlock

	methodsListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 11:29'!
methodsShortcuts: aBlock

	methodsListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 16:10'!
model

	^ model! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
newSet

	| aSet |
	self okToChange ifFalse: [ ^ self ].
	aSet := self model createNewSet.
	aSet ifNotNil:
		[	self updateChangesList.
			changesListModel setSelectedItem: aSet ]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/7/2012 10:45'!
openChangeSetBrowser
	| cs env |
	
	cs := self selectedChangeSet.
	cs ifNil: [ ^ nil ].
	
	env := RBBrowserEnvironment new forClasses: cs changedClasses.

	Smalltalk tools browser fullOnEnvironment: env! !

!ChangeSorterApplication methodsFor: 'display' stamp: 'BenjaminVanRyseghem 2/4/2012 16:13'!
openWithSpec

	window := super openWithSpec.
	^ window! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 16:46'!
registerChangeActions
	
	changesListModel
		whenSelectedItemChanges: [:change | 
			classesListModel resetSelection.
			self updateTextContents.
			change 
				ifNil: [
					classesListModel items: {}.
					methodsListModel items: {}.
					self title: self defaultTitle ]
				ifNotNil: [
					classesListModel items: (change changedClasses sort: [:a :b | a name < b name ]).
					self title: change name ]].
	! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 09:56'!
registerClassActions
	
	classesListModel whenSelectedItemChanges: [:class | 
		methodsListModel resetSelection.
		self updateTextContents.
		textModel behavior: class.
		textModel aboutToStyle: false.
		class 
			ifNil: [ methodsListModel items: {} ]
			ifNotNil: [ methodsListModel items: (self selectedChangeSet selectorsInClass: class name) sort ]].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:19'!
registerSelectorActions

	methodsListModel whenSelectedItemChanges: [:selector |
		self updateTextContents ]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
remove
	"Completely destroy my change set.  Check if it's OK first"

	self okToChange ifFalse: [^ self].
	self model removeChangeSet: self selectedChangeSet prompting: true.
	self updateChangesList.
	changesListModel resetSelection! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/5/2012 23:04'!
removeClass
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	(self model removeClass: self selectedClass)
		ifTrue: [ self setSelectedChangeSet: self selectedChangeSet ]! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:12'!
removeMessage
	"Remove the selected message from the system."
	
	self okToChange
		ifFalse: [^ self].
	self selectedSelector
		ifNotNil: [:selector |
				(self model removeMethod: selector inClass: self selectedClass)
					ifTrue: [ self updateMessagesList ]]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:29'!
removePostscript

	self model removePostscriptFrom: self selectedChangeSet.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:25'!
removePreamble

	self selectedChangeSet removePreamble.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 21:11'!
rename

	| set |
	set := self model rename: self selectedChangeSet.
	
	changesListModel 
		updateList;
		setSelectedItem: set! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 16:07'!
selectedChangeSet

	 ^ changesListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/5/2012 21:58'!
selectedChangeSetIndex

	 ^ changesListModel selectedIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 16:07'!
selectedClass

	 ^ classesListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 10:07'!
selectedClassIndex

	 ^ classesListModel selectedIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 16:44'!
selectedSelector

	 ^ methodsListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/6/2012 03:25'!
selectorsMenu: aBlock

	methodsListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 20:01'!
setCurrentChangeSet

	self model setCurrentChangeSet: self selectedChangeSet.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 16:59'!
setFocus

	self focusOrder
		add: changesListModel;
		add: classesListModel;
		add: methodsListModel;
		add: textModel.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/5/2012 22:20'!
setSelectedChangeSet: aChangeSet

	 ^ changesListModel setSelectedItem: aChangeSet! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/5/2012 22:02'!
setSelectedChangeSetIndex: anIndex

	 ^ changesListModel setSelectedIndex: anIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 08:51'!
setSelectedClass: aClass

	 ^ classesListModel setSelectedItem: aClass! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 10:07'!
setSelectedClassIndex: anIndex

	 ^ classesListModel setSelectedIndex: anIndex! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 15:26'!
textModel

	^ textModel! !

!ChangeSorterApplication methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/4/2012 16:11'!
title

	^ title! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/5/2012 16:56'!
title: aTitle

	title := aTitle.
	window ifNotNil: [ window title: aTitle ]! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
updateChangesList
	| sel |
	
	sel := self selectedChangeSet.
	changesListModel items: self model allChanges.
	changesListModel setSelectedItem: sel.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/5/2012 18:20'!
updateClassesList
	| sel |
	sel := self selectedClass.
	
	self selectedChangeSet
			ifNil: [ classesListModel items: {} ]
			ifNotNil: [:change |	classesListModel items: (change changedClasses sort: [:a :b | a name < b name ])].
				
	classesListModel setSelectedItem: sel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 09:55'!
updateClassesListAndMessagesList
	| sel |
	sel := methodsListModel selectedItem.
	
	self updateClassesList.
	methodsListModel setSelectedItem: sel.
	self updateMessagesList.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 09:56'!
updateMessagesList
	| sel |
	sel := methodsListModel selectedItem.
	
	self selectedClass
			ifNil: [ methodsListModel items: {} ]
			ifNotNil: [:class | methodsListModel items: (self selectedChangeSet selectorsInClass: class name) sort].
				
	methodsListModel setSelectedItem: sel! !

!ChangeSorterApplication methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 11:18'!
updateTextContents

	| text |
	text :=  (self model 
				setContentsOfChangeSet: self selectedChangeSet
				forClass: self selectedClass
				andSelector: self selectedSelector
				prettyPrint: prettyPrint
				showDiff: showDiff).
	({'Method was added, but cannot be found!!'. 'Added then removed (see versions)'. 'Method has been removed (see versions)'} includes: text)
		ifTrue: [ textModel aboutToStyle: false ]
		ifFalse: [ textModel aboutToStyle: true ] .
	textModel text: text.! !

!ChangeSorterApplication methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/5/2012 16:03'!
whenChangesListChanges: aBlock

	changesListModel whenListChanges: aBlock! !

ComposableModel subclass: #CheckBoxExample
	instanceVariableNames: 'button1 button2 button3 container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!CheckBoxExample commentStamp: '<historical>' prior: 0!
A CheckBoxExample is a simple example of how to use CheckBoxes!

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
internSpec

	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		self topSpec.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	(0@0 corner: 1@0).	(0@0 corner: 0@20). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #container.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@1).	(0@22 corner: 0@0). }}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
internSpec2

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.	#internSpec}.
			#addMorph:. {#model.	#button2.	#internSpec}.
			#addMorph:. {#model.	#button3.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/5/2012 17:17'!
title

	^ 'CheckBox Example'! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
topSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.	#internSpec}.
			#addMorph:. {#model.	#button2.	#internSpec}.
			#addMorph:. {#model.	#button3.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button1

	^ button1! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button2

	^ button2! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button3

	^ button3! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
container

	^ container! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:03'!
initialize
	"Initialization code for RadioButtonGroupExample"

	super initialize.

	self instantiateButtons.
	container := PanelMorph new.
	
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	self instantiateMorphs.
	self setFocus.
	self setActions.
	! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 09:30'!
instantiateButtons

	button1 := self instantiate: CheckBoxModel.
	button2 := self instantiate: CheckBoxModel.
	button3 := self instantiate: CheckBoxModel.
	
	button1 label: 'Button 1'.
	button2 label: 'Button 2'.
	button3 label: 'Button 3'.! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActions

	self setActionsForButton1.
	self setActionsForButton2.
	self setActionsForButton3.	! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton1

	button1 whenActivatedDo: [ container addMorph: morph1 ].
	button1 whenDesactivatedDo: [ container removeMorph: morph1 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton2

	button2 whenActivatedDo: [ container addMorph: morph2 ].
	button2 whenDesactivatedDo: [ container removeMorph: morph2 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton3

	button3 whenActivatedDo: [ container addMorph: morph3 ].
	button3 whenDesactivatedDo: [ container removeMorph: morph3 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setFocus
	
	self focusOrder
		add: button1;
		add: button2;
		add: button3.
	! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setGroup

	RadioButtonGroup new 
		addRadioButton: button1;
		addRadioButton: button2;
		addRadioButton: button3;
		default: button1.
	! !

ComposableModel subclass: #CheckBoxModel
	instanceVariableNames: 'actionWhenActivatedHolder actionWhenDesactivatedHolder enabledHolder stateHolder label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!CheckBoxModel commentStamp: '<historical>' prior: 0!
A CheckboxModel is a spec model for Checkbox

The method privateSetState: is really private and should only be used by RadioButtonGroup

You can see self>>#example for an example

You can also have a look at CheckBoxExample for a full example of how to use them with a group.
!

!CheckBoxModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:07'!
internSpec

	^ {#CheckboxMorph.
	    		#on:selected:changeSelected:. 	#model. #state. #state:.
			#label:.								{	#model. #label		}.
			#beCheckbox.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!CheckBoxModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
title

	^ 'Radio Button'! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
actionWhenActivatedHolder
	
	^ actionWhenActivatedHolder! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
actionWhenDesactivatedHolder
	
	^ actionWhenDesactivatedHolder! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
activationAction: aBlock

	"This method is used to set the action to perform when I am activated"
	self actionWhenActivatedHolder contents: aBlock! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
desactivationAction: aBlock

	"This method is used to set the action to perform when I am desactivated"
	self actionWhenDesactivatedHolder contents: aBlock! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
enabled: aBoolean

	self enabledHolder contents: aBoolean! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
enabledHolder
	
	^ enabledHolder! !

!CheckBoxModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:54'!
eventStringForNextFocus

	^ '<right>'! !

!CheckBoxModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:54'!
eventStringForPreviousFocus

	^ '<left>'! !

!CheckBoxModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:07'!
initialize
	"Initialization code for RadioButton"

	super initialize.
	
	actionWhenActivatedHolder := [] asValueHolder.
	actionWhenDesactivatedHolder := [] asValueHolder.
	enabledHolder := true asValueHolder.
	stateHolder := false asValueHolder.
	stateHolder whenChangedDo: [:bool |
		bool
			ifTrue: actionWhenActivatedHolder contents
			ifFalse: actionWhenDesactivatedHolder contents ].! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
label
	
	^ label! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
label: aString

	label := aString.
	self morph
		ifNotNil: [:m | m label: label ]! !

!CheckBoxModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
state

	^ self stateHolder contents! !

!CheckBoxModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 01:07'!
state: aBoolean

	self stateHolder contents: aBoolean! !

!CheckBoxModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
stateHolder
	
	^ stateHolder! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
whenActivatedDo: aBlock

	"This method is used to propagate the event that I have been activated" 
	self stateHolder whenChangedDo: [:bool | bool ifTrue: aBlock ]! !

!CheckBoxModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 01:05'!
whenDesactivatedDo: aBlock

	"This method is used to propagate the event that I have been desactivated"
	self stateHolder whenChangedDo: [:bool | bool ifFalse: aBlock ]! !

ComposableModel subclass: #ClassMethodBrowser
	instanceVariableNames: 'listModel methodModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!ClassMethodBrowser commentStamp: '<historical>' prior: 0!
A ClassMethodBrowser is a simple browser using spec and reusing MethodBrowser to browse classes>>methods>>sourceCode.
	| cb |
	cb := ClassMethodBrowser new.
	cb openWithSpec.
	cb classes: Smalltalk allClasses.!

!ClassMethodBrowser class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/2/2012 13:39'!
example

	"self example"
	| cb |
	cb := ClassMethodBrowser new.
	cb openWithSpec.
	cb classes: Smalltalk allClasses.! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 13:41'!
internSpec
	| halfsize |
	halfsize := 12.
	^ { #PanelMorph.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #listModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 ( 0@0 corner: 0.5@0.5 ).	(0@0 corner: 0@(halfsize negated)). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #methodModel. #listModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	( 0.5@0 corner: 1@0.5 ).	(0@0 corner: 0@(halfsize negated)). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #methodModel. #toolbarModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@0.5).	(0@(halfsize negated) corner: 0@halfsize). }}.										
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #methodModel. #textModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@1).	(0@halfsize corner: 0@0). }}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/31/2012 14:46'!
internSpec2

	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #methodModel. #listModel. #internSpec.}.
											#frame:. 	( 0@0 corner: 0.5@0.5 )}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #listModel. #internSpec.}.
											#frame:. 	( 0.5@0 corner: 1@0.5 )}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #methodModel. #textModel. #internSpec.}.
											#frame:.	( 0@0.5 corner: 1@1 )}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/14/2011 18:12'!
title

	^ 'Class Method Browser'! !

!ClassMethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/15/2012 22:53'!
classes: aList

	self listHolder contents: aList! !

!ClassMethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/31/2012 13:15'!
initialize
	"Initialization code for ClassMethodBrowser"

	super initialize.

	listModel := self instantiate: ListComposableModel.
	methodModel := self instantiate: MethodBrowser.
	
	self focusOrder
		add: listModel;
		add: methodModel.
	
	listModel whenSelectedItemChanges: [:selection |
		selection 
			ifNotNil: [:class | 
				methodModel methods: (class methodDict values sort: [:a :b | a selector < b selector]).
				methodModel listModel resetSelection ]].
	
	methodModel wrapWith: [:method | method selector ].! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/15/2012 22:35'!
listHolder

	^ listModel listHolder! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 18:03'!
listModel

	^ listModel! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 18:03'!
methodModel

	^ methodModel! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:57'!
internSpec

	^ self subclassresponsibility! !

!ComposableModel class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/17/2012 03:20'!
owner: owner

	^ self new
		owner: owner;
		yourself! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:07'!
title
	
	^ 'Untitled window'! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:08'!
windowSpec

	^{ #StandardWindow.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	self internSpec.
											#frame:.	(	0@0 corner: 1@1)	}.
			#title:.					self title}! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/1/2012 18:24'!
addAll: aWindow withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		frame: (0@0 corner: 1@1).! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:38'!
buildWithSpec

	^ self buildWithSpec: #internSpec! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:25'!
buildWithSpec: aSpec

	^ SpecInterpreter buildMorphFor: self withSpec: aSpec! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:52'!
eventStringForNextFocus

	^ ''! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:52'!
eventStringForPreviousFocus

	^ ''! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/17/2012 17:40'!
focusOrder

	^ focusOrder ifNil: [ focusOrder := OrderedCollection new ].! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 11:09'!
giveFocusToNextFrom: aMorph

	| focus |

	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index next |
			index := (focus indexOf: aMorph) + 1.
			(index <= focus size)
				ifTrue: [
					next := focus at: index.
					^ next takeKeyboardFocus ]].

	owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: 1 ifAbsent: [ ^ self ].
			next takeKeyboardFocus ]
		ifNotNil: [ owner giveFocusToNextFrom: self ]! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/23/2012 19:18'!
giveFocusToPreviousFrom: aMorph 

	| focus |
	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index previous |
			index := (focus indexOf: aMorph) - 1.
			(index > 0)
				ifTrue: [
					previous := focus at: index.
					^ previous takeLastKeyboardFocus ]].

	owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: focus size ifAbsent: [ ^ self ].
			next takeLastKeyboardFocus ]
		ifNotNil: [ owner giveFocusToPreviousFrom: self ]! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/18/2012 01:31'!
handlesKeyboard: evt

	^ true! !

!ComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/31/2012 13:15'!
instantiate: aComposableModelClass

	^ aComposableModelClass owner: self! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:13'!
internSpec

	^ self class internSpec! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 18:40'!
isEventForNextFocus: aKeyboardEvent

	^ false! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 18:40'!
isEventForPreviousFocus: aKeyboardEvent 
	
	^ false! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 11:03'!
keyStroke: anEvent fromMorph: aMorph

	((self isEventForNextFocus: anEvent) or: [ anEvent keyString = self eventStringForNextFocus])
		ifTrue: [ ^ self giveFocusToNextFrom: aMorph ].
		
	((self isEventForPreviousFocus: anEvent) or: [ anEvent keyString = self eventStringForPreviousFocus])
		ifTrue: [ ^ self giveFocusToPreviousFrom: aMorph ].
		
	^ false! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 22:21'!
morph

	^ morph! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 22:21'!
morph: anObject
	
	morph := anObject! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/21/2011 13:33'!
openMorphWithSpec

	^ self buildWithSpec openInWorld! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:26'!
openWithSpec

	^ self openWithSpec: #internSpec.! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:27'!
openWithSpec: aSpec
	| window |

	window := StandardWindow new.
	self addAll: window withSpec: aSpec.
	window openInWorld.
	window title: self title.
	self takeKeyboardFocus.
	^ window! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/17/2012 18:31'!
owner: anObject
	
	owner := anObject! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/18/2012 02:10'!
takeKeyboardFocus

	self focusOrder ifNotEmpty:[:focus | ^ focus first takeKeyboardFocus ].
	^ self morph ifNotNil: [:m | m takeKeyboardFocus ]! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 19:51'!
takeLastKeyboardFocus

	self focusOrder
		ifEmpty: [ self takeKeyboardFocus ]
		ifNotEmpty: [:focus | focus last takeKeyboardFocus ].! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/21/2011 13:32'!
title

	^ self class title! !

ComposableModel subclass: #DropListExample
	instanceVariableNames: 'dropList container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!DropListExample commentStamp: '<historical>' prior: 0!
A DropListExample is a simple example of how to use drop lists.

DropListExample new openWithSpec!

!DropListExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/5/2012 17:17'!
internSpec

	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		self topSpec.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	(0@0 corner: 1@0).	(0@0 corner: 0@30). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #container.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@1).	(0@42 corner: 0@0). }}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!DropListExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/5/2012 17:17'!
title

	^ 'Drop list'! !

!DropListExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 15:36'!
topSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#dropList.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
blueMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph2 ]! !

!DropListExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 15:20'!
container

	^ container! !

!DropListExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 15:36'!
dropList

	^ dropList! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
greenMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph3 ]! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:47'!
initialize
	"Initialization code for RadioButtonGroupExample"

	super initialize.

	container := PanelMorph new.
	self instantiateMorphs.
	self instantiateDropList.
	
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	self setFocus.
	! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:37'!
instantiateDropList

	| item1 item2 item3 |

	dropList := self instantiate: DropListModel.	
	item1 := DropListItem named: 'Red morph' do: self redMorphBlock.
	item2 := DropListItem named: 'Blue morph' do: self blueMorphBlock.
	item3 := DropListItem named: 'Green morph' do: self greenMorphBlock.
	
	dropList items: {item1. item2. item3}! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:20'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
redMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph1 ]! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:26'!
setFocus
	
	self focusOrder
		add: dropList;
		add: container.
	! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:20'!
setGroup

	RadioButtonGroup new 
		addRadioButton: button1;
		addRadioButton: button2;
		addRadioButton: button3;
		default: button1.
	! !

ComposableModel subclass: #DropListModel
	instanceVariableNames: 'listHolder selectionHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!DropListModel commentStamp: '<historical>' prior: 0!
A DropListModel is a Spec model for drop lists.

I am assume there is a little problem on an empty list, but frankly, who creates an empty drop list ?!

!DropListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 11:03'!
internSpec

	^ {#DropList.
	    		#on:list:selected:changeSelected:. 	#model. #getList. #getIndex. #setIndex:.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!DropListModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 13:21'!
title

	^ 'Drop List'! !

!DropListModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:54'!
eventStringForNextFocus

	^ '<right>'! !

!DropListModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:54'!
eventStringForPreviousFocus

	^ '<left>'! !

!DropListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 13:33'!
getIndex

	^ self selectionHolder index contents! !

!DropListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 14:45'!
getList

	^ self listHolder contents collect: #label! !

!DropListModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 14:51'!
initialize
	"Initialization code for DropListModel"

	super initialize.

	listHolder := {} asValueHolder.
	selectionHolder := SelectionValueHolder new.
	
	listHolder whenChangedDo: [ 
					self changed: #getList.
					self internalResetSelection. ].
				
	selectionHolder whenChangedDo: [ self changed: #getIndex ].
	self whenSelectedItemChanges: [:item | item value ]! !

!DropListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 14:14'!
internalResetSelection

	self selectionHolder reset.
	self getList isEmpty not
		ifTrue: [ self setSelectedIndex: 1 ]! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:48'!
items: aList

	listHolder contents: aList! !

!DropListModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 13:29'!
listHolder
	
	^ listHolder! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 14:14'!
resetSelection

	self selectionHolder reset! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:37'!
selectedIndex
	"Useless method but it denies a better and more consistent API"

	^ self getIndex! !

!DropListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 13:34'!
selectedIndexHolder

	^ self selectionHolder index! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:45'!
selectedItem

	^ self selectedItemHolder contents! !

!DropListModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 13:34'!
selectedItemHolder

	^ self selectionHolder selection! !

!DropListModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 13:29'!
selectionHolder
	
	^ selectionHolder! !

!DropListModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/2/2012 14:45'!
setIndex: anIndex

	self selectionHolder index contents: anIndex.
	self selectionHolder selection contents: (self listHolder contents at: anIndex ifAbsent: [ nil ]).
	self changed: #getIndex! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 14:48'!
setSelectedIndex: anIndex

	| selection |
	selection := self listHolder contents at: anIndex ifAbsent: [ ^ self ].
	selectionHolder index contents: anIndex.
	selectionHolder selection contents: selection! !

!DropListModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:46'!
setSelectedItem: anItem

	| index |
	index := self getList identityIndexOf: anItem ifAbsent: [ ^ self ].
	selectionHolder index contents: index.
	selectionHolder selection contents: anItem! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 13:46'!
whenSelectedItemChanges: aBlock

	self selectionHolder selection whenChangedDo: aBlock! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/9/2012 17:22'!
whenSelectionChanges: aBlock

	self selectionHolder whenChangedDo: aBlock.! !

!DropListModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/2/2012 13:47'!
whenSelectionIndexChanges: aBlock

	self selectionHolder index whenChangedDo: aBlock! !

ComposableModel subclass: #DualChangeSorterApplication
	instanceVariableNames: 'model changeSorterLeft changeSorterRight isRefreshing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-ChangeSorter'!

!DualChangeSorterApplication commentStamp: '<historical>' prior: 0!
A DualChangeSorterApplication is a dual change sorter based on psec!

!DualChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/5/2012 16:06'!
internSpec

	^ {#Panel.
			#changeTableLayout.
			#listDirection:.	#rightToLeft.
			#addMorph:.	{	#model.	#changeSorterLeft.			#internSpec	}.
			#addMorph:.	{	#model.	#changeSorterRight.		#internSpec	}}! !

!DualChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/5/2012 19:27'!
title

	^'Dual Change Sorter'! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/5/2012 16:08'!
changeSorterLeft

	^ changeSorterLeft! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/5/2012 16:07'!
changeSorterRight

	^ changeSorterRight! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/5/2012 18:09'!
checkThatSidesDiffer: escapeBlock
	"If the change sets on both sides of the dual sorter are the same, put up an error message and escape via escapeBlock, else proceed happily"

	changeSorterLeft selectedChangeSet == changeSorterRight selectedChangeSet
		ifTrue:
			[self inform: 
'This command requires that the
change sets selected on the two
sides of the change sorter *not*
be the same.'.
			^ escapeBlock value]
! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/5/2012 18:50'!
copyAllToLeft

	self checkThatSidesDiffer: [ ^ self ].
	self model copyAllChangesFrom: (changeSorterRight selectedChangeSet) to: (changeSorterLeft selectedChangeSet).
	changeSorterLeft updateClassesList.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/5/2012 18:49'!
copyAllToRight

	self checkThatSidesDiffer: [ ^ self ].
	self model copyAllChangesFrom: (changeSorterLeft selectedChangeSet) to: (changeSorterRight selectedChangeSet).
	changeSorterRight updateClassesList.! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/6/2012 03:44'!
copyClassToLeft
	"Place these changes in the other changeSet also"

	| otherChangeSet |
	self checkThatSidesDiffer: [ ^ self ].
	self okToChange ifFalse: [ ^ Beeper beep ].
	changeSorterRight selectedClass ifNil: [ ^ Beeper beep ].
	otherChangeSet := changeSorterLeft selectedChangeSet.
	
	self model copyClass: changeSorterRight selectedClass from: changeSorterRight selectedChangeSet to: otherChangeSet.
	
	changeSorterLeft setSelectedChangeSet: otherChangeSet.! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/6/2012 03:43'!
copyClassToRight
	"Place these changes in the other changeSet also"

	| otherChangeSet |
	self checkThatSidesDiffer: [ ^ self ].
	self okToChange ifFalse: [ ^ Beeper beep ].
	changeSorterLeft selectedClass ifNil: [ ^ Beeper beep ].
	otherChangeSet := changeSorterRight selectedChangeSet.
	
	self model copyClass: changeSorterLeft selectedClass from: changeSorterLeft selectedChangeSet to: otherChangeSet.
	
	changeSorterRight setSelectedChangeSet: otherChangeSet.! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 2/7/2012 10:00'!
copyMethodToLeft
	"Place this change in the other changeSet also"	
	| other |
	
	self checkThatSidesDiffer: [^ self].
	other := changeSorterLeft selectedChangeSet.
	
	changeSorterRight selectedSelector ifNotNil: [:selector || class |
		class := changeSorterRight selectedClass.
		
		self model 
			copySelector: selector 
			inClass: class 
			from: changeSorterRight selectedChangeSet 
			to: other.
			
		changeSorterLeft updateClassesListAndMessagesList ].! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 2/7/2012 09:59'!
copyMethodToRight
	"Place this change in the other changeSet also"	
	| other |
	
	self checkThatSidesDiffer: [^ self].
	other := changeSorterRight selectedChangeSet.
	
	changeSorterLeft selectedSelector ifNotNil: [:selector || class |
		class := changeSorterLeft selectedClass.

		self model 
			copySelector: selector 
			inClass: class 
			from: changeSorterLeft selectedChangeSet 
			to: other.		
			
		changeSorterRight updateClassesListAndMessagesList ].! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:27'!
initialize
	"Initialization code for DualChangeSorterApplication"

	super initialize.

	changeSorterLeft := self instantiate: ChangeSorterApplication.
	changeSorterRight := self instantiate: ChangeSorterApplication.
	model := ChangeSorterModel new.
	isRefreshing := false.
	
	changeSorterLeft 	whenChangesListChanges: [ self leftChangeSetRefreshed 	].
	changeSorterRight	whenChangesListChanges: [ self rightChangeSetRefreshed	].
			
	self menusRegistration.
	self shortcutsRegistration.
	self setFocusOrder! !

!DualChangeSorterApplication methodsFor: 'event' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
leftChangeSetRefreshed

	isRefreshing
		ifFalse: [
			isRefreshing := true.
			changeSorterRight updateChangesList.
			isRefreshing := false ]! !

!DualChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/7/2012 11:28'!
leftChangeSetShortcuts: event from: aMorph

	event keyString = '<Cmd-c>' 	ifTrue: [ self copyAllToRight ].
	event keyString = '<Cmd-->' 	ifTrue: [ self subtractRight ].
	
	^ changeSorterLeft changeSetShortcuts: event from: aMorph.! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:45'!
leftChangesMenu: menu shifted: shifted

	changeSorterLeft changeSetMenu1: menu shifted: shifted.
	
	changeSorterLeft selectedChangeSet
		ifNotNil:[
			menu 
				add: 'Copy all to right change set (c)' 
				target: self
				action: #copyAllToRight.
			menu 
				add: 'Submerge into right change set' 
				target: self
				action: #submergeIntoRight.
			menu 
				add: 'Subtract right change set (-)'
				target: self
				action: #subtractRight.
			menu addLine] .
	
	changeSorterLeft changeSetMenu2: menu shifted: shifted.
	^ menu! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:43'!
leftClassMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	changeSorterLeft selectedClass ifNil: [ ^ nil ].
	aMenu target: self.
	aMenu addList: #(
			('Copy class to right change set'			copyClassToRight)	
			('Move class to right change set'			moveClassToRight)
			-
			).
						
	changeSorterLeft classMenu: aMenu shifted: shifted.
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 09:38'!
leftMenusRegistration.
	
	changeSorterLeft changesMenu: [:menu :shifted | self leftChangesMenu: menu shifted: shifted ].
	changeSorterLeft classesMenu: [:menu :shifted | self leftClassMenu: menu shifted: shifted ].
	changeSorterLeft methodsMenu: [:menu :shifted | self leftMessageMenu: menu shifted: shifted ].! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:43'!
leftMessageMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	changeSorterLeft selectedSelector ifNil: [ ^ nil ].	
	aMenu target: self.

	aMenu addList: #(
		('Copy method to  right change set'			copyMethodToRight)
		('Move method to  right change set'			moveMethodToRight)
		-
		).
					
	changeSorterLeft messageMenu: aMenu shifted: shifted.
	
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:32'!
leftShortcutsRegistration.
	
	changeSorterLeft changesShortcuts: [:event :source | self leftChangeSetShortcuts: event from: source ].! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/6/2012 03:29'!
menusRegistration

	self leftMenusRegistration.
	self rightMenusRegistration.! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/5/2012 18:47'!
model

	^ model! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/7/2012 08:42'!
moveClassToLeft

	self checkThatSidesDiffer: [^ self].
	(self okToChange and: [ changeSorterRight selectedClass notNil])
		ifFalse: [ ^ false ].

	self copyClassToLeft.
	changeSorterRight forgetClass! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/7/2012 08:42'!
moveClassToRight

	self checkThatSidesDiffer: [^ self].
	(self okToChange and: [ changeSorterLeft selectedClass notNil])
		ifFalse: [ ^ false ].

	self copyClassToRight.
	changeSorterLeft forgetClass! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 2/7/2012 10:04'!
moveMethodToLeft

	self copyMethodToLeft.
	changeSorterRight forgetMessage.
	changeSorterRight updateClassesListAndMessagesList.! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 2/7/2012 10:06'!
moveMethodToRight

	self copyMethodToRight.
	changeSorterLeft forgetMessage.! !

!DualChangeSorterApplication methodsFor: 'event' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
rightChangeSetRefreshed

	isRefreshing
		ifFalse: [
			isRefreshing := true.
			changeSorterLeft updateChangesList.
			isRefreshing := false ]! !

!DualChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/7/2012 11:29'!
rightChangeSetShortcuts: event from: aMorph

	event keyString = '<Cmd-c>' 	ifTrue: [ self copyAllToLeft ].
	event keyString = '<Cmd-->' 	ifTrue: [ self subtractLeft ].
	
	^ changeSorterRight changeSetShortcuts: event from: aMorph.! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:45'!
rightChangesMenu: menu shifted: shifted

	changeSorterRight changeSetMenu1: menu shifted: shifted.
	
	changeSorterRight selectedChangeSet
		ifNotNil:[
			menu 
				add: 'Copy all to left change set(c)' 
				target: self
				action: #copyAllToLeft.
			menu 
				add: 'Submerge into left change set' 
				target: self
				action: #submergeIntoLeft.
			menu 
				add: 'Subtract left change set (-)'
				target: self
				action: #subtractLeft.
			menu addLine] .
	
	changeSorterRight changeSetMenu2: menu shifted: shifted.
	^ menu! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:42'!
rightClassMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	changeSorterRight selectedClass ifNil: [ ^ nil ].
	aMenu target: self.
	aMenu addList: #(
			('Copy class to left change set'			copyClassToLeft)	
			('Move class to left change set'			moveClassToLeft)
			-
			).
						
	changeSorterRight classMenu: aMenu shifted: shifted.
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 09:39'!
rightMenusRegistration
	
	changeSorterRight changesMenu: [:menu :shifted | self rightChangesMenu: menu shifted: shifted ].
	changeSorterRight classesMenu: [:menu :shifted | self rightClassMenu: menu shifted: shifted ].
	changeSorterRight methodsMenu: [:menu :shifted | self rightMessageMenu: menu shifted: shifted ].! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:42'!
rightMessageMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	changeSorterRight selectedSelector ifNil: [ ^ nil ].	
	aMenu target: self.

	aMenu addList: #(
		('Copy method to left change set'			copyMethodToLeft)
		('Move method to left change set'			moveMethodToLeft)
		-
		).
					
	changeSorterRight messageMenu: aMenu shifted: shifted.
	
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:32'!
rightShortcutsRegistration.
	
	changeSorterRight changesShortcuts: [:event :source | self rightChangeSetShortcuts: event from: source ].! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 10:57'!
setFocusOrder

	self focusOrder
		add: changeSorterLeft;
		add: changeSorterRight.! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:28'!
shortcutsRegistration

	self leftShortcutsRegistration! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
submergeIntoLeft
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	| rightChangeSet other index |

	rightChangeSet := changeSorterRight selectedChangeSet.
	other := changeSorterLeft selectedChangeSet.
	index := changeSorterRight selectedChangeSetIndex.

	(self model submerge: rightChangeSet into: other) ifFalse: [ ^ self ].
	
	changeSorterRight updateChangesList.
	changeSorterRight setSelectedChangeSetIndex: index.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
submergeIntoRight
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	| leftChangeSet other index |

	leftChangeSet := changeSorterLeft selectedChangeSet.
	other := changeSorterRight selectedChangeSet.
	index := changeSorterLeft selectedChangeSetIndex.

	(self model submerge: leftChangeSet into: other) ifFalse: [ ^ self ].
	
	changeSorterLeft updateChangesList.
	changeSorterLeft setSelectedChangeSetIndex: index.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/5/2012 22:24'!
subtractLeft
	"Subtract the changes found on the other side from the requesting side."
	| source destination |
	source := changeSorterRight selectedChangeSet.
	destination := changeSorterLeft selectedChangeSet.
	
	self checkThatSidesDiffer: [^ self].
	
	self model substractFrom: source to: destination.
	
	changeSorterRight setSelectedChangeSet: source.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/5/2012 22:23'!
subtractRight
	"Subtract the changes found on the other side from the requesting side."
	| source destination |
	source := changeSorterLeft selectedChangeSet.
	destination := changeSorterRight selectedChangeSet.

	self checkThatSidesDiffer: [^ self].

	self model substractFrom: source to: destination.

	changeSorterLeft setSelectedChangeSet: source.! !

ComposableModel subclass: #ListComposableModel
	instanceVariableNames: 'selectionHolder listHolder wrapHolder menuHolder shortcutsHolder multiSelectionHolder multiSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ListComposableModel commentStamp: '<historical>' prior: 0!
A ListComposableModel is an applicative model which handle a basic list.

| t |
t:= ListComposableModel new.
t openWithSpec.
t items: (Smalltalk allClasses).
self example!

!ListComposableModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 12/15/2011 13:29'!
example
	| instance |

	instance := self new.
	instance openWithSpec.
	instance listHolder contents: (Smalltalk allClasses).! !

!ListComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/9/2012 17:11'!
internSpec

	^ {#PluggableListMorph.
	    		#model:. 						#model.
			#getListSelector:. 				#getList.
			#getIndexSelector:. 			#getIndex.
			#setIndexSelector:. 			#setIndex:.
			#getSelectionListSelector:.		#getSelectionStateFor:.
			#setSelectionListSelector:.		#setSelectionStateFor:at:.
			#resetListSelector:.				#resetListSelection.
			#getMenuSelector:.			#menu:shifted:.
			#keystrokeSelector:.			#keyStroke:fromMorph:.
			#setMultipleSelection:.			{#model. #multiSelection}.
			#wrapSelector:. 				#wrapItem:.
			#hResizing:. 					#spaceFill.
			#vResizing:. 					#spaceFill}! !

!ListComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:09'!
title

	^ 'List'! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 16:15'!
beMultipleSelection

	self multiSelection: true! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 16:15'!
beSingleSelection

	self multiSelection: false! !

!ListComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:51'!
eventStringForNextFocus

	^ '<right>'! !

!ListComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:52'!
eventStringForPreviousFocus

	^ '<left>'! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:50'!
getIndex

	^ self selectionHolder index contents! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 1/9/2012 17:47'!
getList

	^ self listHolder contents ifNil: [ {} ]! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/9/2012 16:58'!
getSelectionStateFor: anIndex

	^ (multiSelectionHolder at: anIndex ifAbsent: [ ^ false ]) == true! !

!ListComposableModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 2/9/2012 17:21'!
initialize

	super initialize.
	selectionHolder := SelectionValueHolder new.
	listHolder := Array new asValueHolder.
	wrapHolder := [:object | object asStringOrText ] asValueHolder.
	menuHolder := [:menu :shifted | nil ] asValueHolder.
	shortcutsHolder := [:event :sourceMorph | ] asValueHolder.
	multiSelectionHolder := IdentityDictionary new asValueHolder.
	multiSelection := false.
	
	listHolder whenChangedDo: [ self changed: #getList ].
	selectionHolder whenChangedDo: [ self changed: #getIndex ].! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 00:48'!
items: aList

	listHolder contents: aList! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/7/2012 11:21'!
keyStroke: anEvent fromMorph: aMorph

	super keyStroke: anEvent fromMorph: aMorph.
	
	^ self shortcutsHolder contents cull: anEvent cull: aMorph! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
listHolder

	^ listHolder! !

!ListComposableModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 12:25'!
menu: aBlock

	self menuHolder contents: aBlock! !

!ListComposableModel methodsFor: 'morphic' stamp: 'SimonAllier 1/27/2012 12:24'!
menu: aMenu shifted: aBoolean

	^ self menuHolder contents cull: aMenu cull: aBoolean! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
menuHolder

	^ menuHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 17:10'!
multiSelection

	^ multiSelection! !

!ListComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/9/2012 16:16'!
multiSelection: aBoolean

	multiSelection := aBoolean.
	morph ifNotNil: [ morph setMultipleSelection: multiSelection ]! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 16:22'!
multiSelectionHolder

	^ multiSelectionHolder! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/9/2012 16:59'!
resetListSelection

	multiSelectionHolder removeAll! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/7/2012 06:44'!
resetSelection

	self selectionHolder reset! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:36'!
selectedIndex
	"Useless method but it denies a better and more consistent API"

	^ self getIndex! !

!ListComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/31/2012 15:49'!
selectedIndexHolder

	^ self selectionHolder index! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:09'!
selectedIndexes
	
	^ multiSelectionHolder keys select: [:index | multiSelectionHolder at: index ]! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 02:15'!
selectedItem

	^ self selectedItemHolder contents! !

!ListComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/16/2012 01:49'!
selectedItemHolder

	^ self selectionHolder selection! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:09'!
selectedItems

	^ multiSelectionHolder keys select: [:index | multiSelectionHolder at: index ] thenCollect: [:index | self getList at: index ]! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
selectionHolder

	^ selectionHolder! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:50'!
setIndex: anIndex

	self selectionHolder index contents: anIndex.
	self selectionHolder selection contents: (self getList at: anIndex ifAbsent: [ nil ]).
	self changed: #getIndex! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 00:48'!
setSelectedIndex: anIndex

	| selection |
	selection := self getList at: anIndex ifAbsent: [ ^ self ].
	selectionHolder index contents: anIndex.
	selectionHolder selection contents: selection! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 00:48'!
setSelectedItem: anItem

	| index |
	index := self getList identityIndexOf: anItem ifAbsent: [ ^ self ].
	selectionHolder index contents: index.
	selectionHolder selection contents: anItem! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/9/2012 17:00'!
setSelectionStateFor: anIndex at: aBoolean

	^ multiSelectionHolder at: anIndex put: aBoolean! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 10:48'!
shortcuts: aBlock

	self shortcutsHolder contents: aBlock! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/7/2012 10:24'!
shortcutsHolder

	^ shortcutsHolder! !

!ListComposableModel methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 12:09'!
updateList

	self changed: #getList.
	self resetSelection! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/5/2012 16:03'!
whenListChanges: aBlock

	self listHolder whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 1/16/2012 02:02'!
whenSelectedItemChanges: aBlock

	self selectionHolder selection whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/9/2012 17:22'!
whenSelectionChanges: aBlock

	self selectionHolder whenChangedDo: aBlock.
	self multiSelectionHolder whenChangedDo: aBlock.! !

!ListComposableModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 1/16/2012 02:08'!
whenSelectionIndexChanges: aBlock

	self selectionHolder index whenChangedDo: aBlock! !

!ListComposableModel methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:27'!
wrapHolder

	^ wrapHolder! !

!ListComposableModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:35'!
wrapItem: anObject

	^ self wrapHolder contents value: anObject! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 00:47'!
wrappingBlock: aBlock

	wrapHolder contents: aBlock! !

ComposableModel subclass: #ListSelectionModel
	instanceVariableNames: 'listModel textModel1 textModel2 textRefreshingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!ListSelectionModel commentStamp: '<historical>' prior: 0!
A ListSelectionModel is a basic example to show multi selection on lists

| l |
l := ListSelectionModel new.
l openWithSpec!

!ListSelectionModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/9/2012 17:08'!
bottomSpec

	^ {#Panel.
			#changeTableLayout.
			#listDirection:.			#rightToLeft.
			#addMorph:.			{#model.	#textModel1.	#internSpec}.
			#addMorph:.			{#model.	#textModel2.	#internSpec}.
			#hResizing:.	#spaceFill.
			#vResizing:.	#spaceFill.}! !

!ListSelectionModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/9/2012 17:08'!
internSpec

	^ {#Panel.
			#changeTableLayout.
			#listDirection:.			#bottomToTop.
			#addMorph:.			{#model.	#listModel.		#internSpec}.
			#addMorph:.			self bottomSpec.
			#hResizing:.	#spaceFill.
			#vResizing:.	#spaceFill.}! !

!ListSelectionModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/9/2012 18:05'!
initialize
	"Initialization code for ListSelectionModel"

	super initialize.

	listModel := self instantiate: ListComposableModel.
	textModel1 := self instantiate: TextModel.
	textModel2 := self instantiate: TextModel.
	
	listModel beMultipleSelection.
	
	listModel items: Smalltalk allClasses.
	listModel whenSelectionChanges: [ self updateText ]! !

!ListSelectionModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 17:06'!
listModel

	^ listModel! !

!ListSelectionModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 17:07'!
textModel1

	^ textModel1! !

!ListSelectionModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 17:07'!
textModel2

	^ textModel2! !

!ListSelectionModel methodsFor: 'update' stamp: 'BenjaminVanRyseghem 2/9/2012 18:07'!
updateText
	"update the displayed list in a separate thread to avoid UI blocking"
	
	"if there is already a background thread running for the new list discard it"
	textRefreshingProcess ifNotNil: [
		textRefreshingProcess terminate].
	
	"fork off a possibly costly list calculation"
	textRefreshingProcess := [
		| indexes items |
		indexes := listModel selectedIndexes sort collect: [:i | i printString ].
		indexes :=  (indexes joinUsing: '; ').
		items := listModel selectedItems collect: [:i | i printString ].
		items := (items sort joinUsing: '; ').
		WorldState addDeferredUIMessage: [
			textModel1 text: indexes.
			textModel2 text: items]] fork.! !

ComposableModel subclass: #MethodBrowser
	instanceVariableNames: 'listModel textModel toolbarModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!MethodBrowser commentStamp: '<historical>' prior: 0!
A MethodBrowser is a simple browser using Spec to display a list of methods and their source code

	si := MethodBrowser new.
	si openWithSpec.
	si methods: Object methodDict values!

!MethodBrowser class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 1/16/2012 23:18'!
example

	| mb |
	mb := MethodBrowser new.
	mb openWithSpec.
	mb methods: Object methodDict values! !

!MethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/18/2012 01:58'!
internSpec

	^{ #PanelMorph.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #listModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@0.5).	(0@0 corner: 0@(-15)). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #toolbarModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@0.5).	(0@(-15) corner: 0@15). }}.															
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #textModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@1).	(0@15 corner: 0@0). }}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!MethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/31/2012 13:32'!
internSpec2
^{ #Panel.
		#changeTableLayout.
		#listDirection:. 	#bottomToTop.
		#addMorph:. 		{#model. #listModel. #internSpec.}.
		#addMorph:. 		{#model. #textModel. #internSpec.}.
		#vResizing:.		 #spaceFill.
		#hResizing:.		 #spaceFill.}! !

!MethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/31/2012 13:36'!
title

	^ 'Method Browser'! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:42'!
action

	^ textModel actionToPerformHolder content! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:42'!
action: aBlock

	textModel action: aBlock! !

!MethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 14:36'!
initialize
	"Initialization code for MethodBrowser"

	super initialize.

	listModel := self instantiate: ListComposableModel.
	textModel := self instantiate: TextModel.
	toolbarModel := self instantiate: MethodToolbar.
	
	self focusOrder
		add: listModel;
		add: toolbarModel;
		add: textModel.
	
	listModel whenSelectedItemChanges: [:selection |
		selection
			ifNil: [
				textModel text: ''.
				textModel behavior: nil.
				toolbarModel method: nil ]
			ifNotNil: [:m | 
				textModel text: m sourceCode.
				textModel behavior: m methodClass.
				toolbarModel method: m ]].
	
	self action: [:t | self listModel selectedItem inspect ].
	textModel aboutToStyle: true.
	self wrapWith: [:item | item methodClass name,'>>#', item selector ].! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/15/2012 22:31'!
listHolder

	^ listModel listHolder! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:51'!
listModel

	^ listModel! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/31/2012 13:10'!
methods: aList

	"Here I reroute my entry point to the list model's entry point"
	self listModel items: aList! !

!MethodBrowser methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 03:16'!
takeKeyboardFocus

	^ self listModel takeKeyboardFocus! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:51'!
textModel

	^ textModel! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2012 01:58'!
toolbarModel

	^ toolbarModel! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 23:02'!
wrapWith: aBlock

	listModel wrappingBlock: aBlock! !

ComposableModel subclass: #MethodToolbar
	instanceVariableNames: 'methodHolder browseModel sendersModel versionModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!MethodToolbar commentStamp: '<historical>' prior: 0!
A MethodToolbar is xxxxxxxxx.

b := MethodToolbar new.
b openWithSpec.
b method: (ButtonModel>>#state:).
b method: nil!

!MethodToolbar class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/9/2012 17:08'!
internSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#browseModel.	#internSpec}.
			#addMorph:. {#model.	#sendersModel.	#internSpec}.
			#addMorph:. {#model.	#versionModel.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!MethodToolbar class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/18/2012 01:04'!
title

	^ 'Toolbar'! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/1/2012 18:26'!
addAll: aWindow  withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		fullFrame: (LayoutFrame 
			fractions: (0@0 corner: 1@0) 
			offsets: (0@0 corner: 0@30)).! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2012 01:22'!
browseMethod

	methodHolder contents
		ifNotNil: [:aMethod | aMethod browse ]! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2012 01:17'!
browseModel

	^ browseModel! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/31/2012 13:15'!
initialize
	"Initialization code for MethodToolbar"

	super initialize.

	methodHolder := nil asValueHolder.
	browseModel := self instantiate: ButtonModel.
	sendersModel := self instantiate: ButtonModel.
	versionModel := self instantiate: ButtonModel.

	self setFocusOrder.
	
	self setBrowseModel.
	self setVersionModel.
	self setSendersModel.

	self registerForChanges.! !

!MethodToolbar methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 00:35'!
method: aMethod

	methodHolder contents: aMethod! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 01:04'!
registerForChanges

	methodHolder whenChangedDo: [:contents || boolean |
		boolean := contents
						ifNil: [ false ]
						ifNotNil: [ true ].
		browseModel state: boolean.
		sendersModel state: boolean.
		versionModel state: boolean.]! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2012 01:21'!
sendersMethod

	methodHolder contents
		ifNotNil: [:aMethod | 
			| strm array |
			strm := (array := Array new: {} size + 1) writeStream.
			strm nextPut: nil.
			strm nextPutAll: {}.

			aMethod ifNil: [ | selector |
				selector := UIManager default request: 'Type selector:' initialAnswer: 'flag:'.
				selector ifNil: [selector := String new].
				selector := selector copyWithout: Character space.
				^ selector isEmptyOrNil ifFalse: [
					(Symbol hasInterned: selector
						ifTrue: [ :aSymbol |
							array at: 1 put: aSymbol.
							self systemNavigation perform: #browseAllCallsOn: withArguments: array])
						ifFalse: [ self inform: 'no such selector']
				]
			].

			array at: 1 put: aMethod selector.
			self systemNavigation perform: #browseAllCallsOn: withArguments: array]! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2012 01:17'!
sendersModel

	^ sendersModel! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 01:13'!
setBrowseModel
	
	browseModel
		state: false;
		label: 'Browse';
		action: [ self browseMethod ].
	
! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 00:36'!
setFocusOrder

	self focusOrder
		add: browseModel;
		add: sendersModel;
		add: versionModel.
		! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 01:18'!
setSendersModel
	
	sendersModel
		state: false;
		label: 'Senders';
		action: [ self sendersMethod ].
	
! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 01:13'!
setVersionModel
	
	versionModel
		state: false;
		label: 'Version';
		action: [ self versionMethod ].
	
! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2012 01:22'!
versionMethod

	methodHolder contents
		ifNotNil: [:aMethod | 
			| selector class | 
	(selector := aMethod selector)
		ifNil: [ self inform: 'Sorry, only actual methods have retrievable versions.'. ^nil ]
		ifNotNil: [
			class := aMethod methodClass.
			(VersionsBrowser
				browseVersionsOf: aMethod
				class: class
				meta: class isMeta
				category: aMethod category
				selector: selector)]]! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2012 01:17'!
versionModel

	^ versionModel! !

ComposableModel subclass: #RadioButtonGroupExample
	instanceVariableNames: 'button1 button2 button3 container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!RadioButtonGroupExample commentStamp: '<historical>' prior: 0!
A RadioButtonGroupExample is an simple example about how to use RadioButtons and RadioGroup!

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 00:45'!
internSpec

	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		self topSpec.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	(0@0 corner: 1@0).	(0@0 corner: 0@20). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #container.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@1).	(0@22 corner: 0@0). }}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 00:34'!
internSpec2

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.	#internSpec}.
			#addMorph:. {#model.	#button2.	#internSpec}.
			#addMorph:. {#model.	#button3.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/1/2012 17:51'!
title

	^ 'Radio Button Group Example'! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 00:38'!
topSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.	#internSpec}.
			#addMorph:. {#model.	#button2.	#internSpec}.
			#addMorph:. {#model.	#button3.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button1

	^ button1! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button2

	^ button2! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button3

	^ button3! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 00:39'!
container

	^ container! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:59'!
initialize
	"Initialization code for RadioButtonGroupExample"

	super initialize.

	self instantiateButtons.
	container := PanelMorph new.
	
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	self instantiateMorphs.
	self setFocus.
	self setActions.
	self setGroup.
	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:55'!
instantiateButtons

	button1 := self instantiate: RadioButtonModel.
	button2 := self instantiate: RadioButtonModel.
	button3 := self instantiate: RadioButtonModel.
	
	button1 label: 'Button 1'.
	button2 label: 'Button 2'.
	button3 label: 'Button 3'.! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:00'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:50'!
setActions

	self setActionsForButton1.
	self setActionsForButton2.
	self setActionsForButton3.	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton1

	button1 whenActivatedDo: [ container addMorph: morph1 ].
	button1 whenDesactivatedDo: [ container removeMorph: morph1 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton2

	button2 whenActivatedDo: [ container addMorph: morph2 ].
	button2 whenDesactivatedDo: [ container removeMorph: morph2 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton3

	button3 whenActivatedDo: [ container addMorph: morph3 ].
	button3 whenDesactivatedDo: [ container removeMorph: morph3 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:47'!
setFocus
	
	self focusOrder
		add: button1;
		add: button2;
		add: button3.
	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:49'!
setGroup

	RadioButtonGroup new 
		addRadioButton: button1;
		addRadioButton: button2;
		addRadioButton: button3;
		default: button1.
	! !

ComposableModel subclass: #RadioButtonModel
	instanceVariableNames: 'actionWhenActivatedHolder actionWhenDesactivatedHolder enabledHolder stateHolder label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!RadioButtonModel commentStamp: '<historical>' prior: 0!
A RadioButtonModel is a spec model for RadioButton

!! The method privateSetState: is really private and should only be used by RadioButtonGroup !!

You can also have a look at RadioButtonGroupExample for a full example of how to use them with a group.!

!RadioButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/2/2012 13:07'!
internSpec

	^ {#Checkbox.
	    		#on:selected:changeSelected:. 	#model. #state. #state:.
			#label:.								{	#model. #label		}.
			#beRadioButton.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!RadioButtonModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/1/2012 13:35'!
title

	^ 'Radio Button'! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
actionWhenActivatedHolder
	
	^ actionWhenActivatedHolder! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
actionWhenDesactivatedHolder
	
	^ actionWhenDesactivatedHolder! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 17:44'!
activationAction: aBlock

	"This method is used to set the action to perform when I am activated"
	self actionWhenActivatedHolder contents: aBlock! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 17:44'!
desactivationAction: aBlock

	"This method is used to set the action to perform when I am desactivated"
	self actionWhenDesactivatedHolder contents: aBlock! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 13:27'!
enabled: aBoolean

	self enabledHolder contents: aBoolean! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
enabledHolder
	
	^ enabledHolder! !

!RadioButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForNextFocus

	^ '<right>'! !

!RadioButtonModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForPreviousFocus

	^ '<left>'! !

!RadioButtonModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/1/2012 17:39'!
initialize
	"Initialization code for RadioButton"

	super initialize.
	
	actionWhenActivatedHolder := [] asValueHolder.
	actionWhenDesactivatedHolder := [] asValueHolder.
	enabledHolder := true asValueHolder.
	stateHolder := true asValueHolder.
	stateHolder whenChangedDo: [:bool |
		bool
			ifTrue: actionWhenActivatedHolder contents
			ifFalse: actionWhenDesactivatedHolder contents ].! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:57'!
label
	
	^ label! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 17:56'!
label: aString

	label := aString.
	self morph
		ifNotNil: [:m | m label: label ]! !

!RadioButtonModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2012 00:57'!
privateSetState: aBoolean

	self stateHolder contents: aBoolean.
	self changed: #state! !

!RadioButtonModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/1/2012 13:44'!
state

	^ self stateHolder contents! !

!RadioButtonModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 14:03'!
state: aBoolean

	self state
		ifFalse: [ self stateHolder contents: true ].! !

!RadioButtonModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 13:49'!
stateHolder
	
	^ stateHolder! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/1/2012 18:00'!
whenActivatedDo: aBlock

	"This method is used to propagate the event that I have been activated" 
	self stateHolder whenChangedDo: [:bool | bool ifTrue: aBlock ]! !

!RadioButtonModel methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/1/2012 18:00'!
whenDesactivatedDo: aBlock

	"This method is used to propagate the event that I have been desactivated"
	self stateHolder whenChangedDo: [:bool | bool ifFalse: aBlock ]! !

ComposableModel subclass: #TestingComposableModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!TestingComposableModel commentStamp: '<historical>' prior: 0!
A TestingComposableModel is a stupid composable model used to test SpecInterpreter!

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/19/2012 16:43'!
internSpec

	^ {#List.
		#model:.	#model.}! !

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/19/2012 17:35'!
testingSpec

	^ {#Text.
		#model:.	#model.}! !

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/19/2012 16:43'!
title

	^ 'You should not see me !!'! !

ComposableModel subclass: #TextFieldExample
	instanceVariableNames: 'methodBrowser textField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!TextFieldExample commentStamp: '<historical>' prior: 0!
A TextFieldExample is a simple example of how to use TextFields.!

!TextFieldExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 14:54'!
internSpec
	| textFieldHeight |
	textFieldHeight := StandardFonts defaultFont height + 15.
	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #textField. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 ( 0@0 corner: 1@0 ).	(0@0 corner: 0@textFieldHeight). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #methodBrowser. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	( 0@0 corner: 1@1 ).	(0@textFieldHeight corner: 0@0). }}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!TextFieldExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
title

	^ 'Text Field Example'! !

!TextFieldExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 14:43'!
initialize
	"Initialization code for TextFieldExample"

	super initialize.

	methodBrowser := self instantiate: MethodBrowser.
	textField := self instantiate: TextInputFieldModel.
	
	textField 
		ghostText: 'Enter a class name';
		autoAccept: true;
		action: [:text | Smalltalk globals at: text asSymbol
								ifPresent: [:class | methodBrowser methods: class methodDict values ]
								ifAbsent: [ methodBrowser methods: {} ]]! !

!TextFieldExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
methodBrowser

	^ methodBrowser! !

!TextFieldExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
textField

	^ textField! !

ComposableModel subclass: #TextInputFieldModel
	instanceVariableNames: 'textHolder actionToPerformHolder ghostText alwaysAccept acceptOnCR autoAccept entryCompletion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!TextInputFieldModel commentStamp: '<historical>' prior: 0!
A TextInputFieldModel is a spec model for TextInputField.!

!TextInputFieldModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/4/2012 14:46'!
example
	| instance |
	
	instance := self new.
	instance openWithSpec.
	instance ghostText: 'This is a ghost'.
	instance text: 'This is a text'! !

!TextInputFieldModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 14:47'!
internSpec

	^ {#TextField.
			#convertTo:. 							String.
			#on:text:accept:readSelection:menu:. 	#model. #getText. #accept:. nil. nil.
			#entryCompletion:. 				{	#model. #entryCompletion	}.
			#autoAccept:.						{	#model. 	#autoAccept			}.	
			#acceptOnCR:. 					{	#model. 	#acceptOnCR			}.
			#ghostText:.						{	#model. 	#ghostText			}.
			#hResizing:. 							#spaceFill.
			#vResizing:. 							#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!TextInputFieldModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
title

	^ 'Text'! !

!TextInputFieldModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
accept: aText

	self textHolder contents: aText.
	self actionToPerformHolder contents cull: aText.
	self changed: #clearUserEdits.! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:21'!
acceptOnCR

	^ acceptOnCR! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:21'!
acceptOnCR: aBoolean

	acceptOnCR := aBoolean
	self morph ifNotNil: [:m | m acceptOnCR: acceptOnCR ]! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:36'!
action: aBlockWithOneArgument

	actionToPerformHolder contents: aBlockWithOneArgument! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
actionToPerformHolder

	^ actionToPerformHolder! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:23'!
autoAccept

	^ autoAccept! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:25'!
autoAccept: aBoolean

	autoAccept := aBoolean.
	self morph ifNotNil: [:m | m autoAccept: autoAccept ]! !

!TextInputFieldModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
defaultEntryCompletion

	| applicants |
	applicants := (Array
				streamContents: [:strm | Symbol
						allSymbolTablesDo: [:each | (each notEmpty
									and: [each first canBeGlobalVarInitial
											and: [Smalltalk globals includesKey: each]])
								ifTrue: [strm nextPut: each]]]) sort.

	^ EntryCompletion new
				dataSourceBlock: [:currText | applicants];
				filterBlock: [:currApplicant :currText | currText size > 3
						and: [currApplicant asUppercase includesSubString: currText asString asUppercase]].! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
entryCompletion

	^ entryCompletion! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
entryCompletion: anEntryCompletion

	entryCompletion := anEntryCompletion.
	self morph ifNotNil: [:m | m entryCompletion: entryCompletion ]! !

!TextInputFieldModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForNextFocus

	^ '<Ctrl-Cmd-right>'! !

!TextInputFieldModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForPreviousFocus

	^ '<Ctrl-Cmd-left>'! !

!TextInputFieldModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 2/4/2012 11:20'!
getText
	
	^ self textHolder contents! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 12:02'!
ghostText

	^ ghostText! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 11:37'!
ghostText: aText

	ghostText := aText translated.
	self morph ifNotNil: [:m | m ghostText: ghostText ]! !

!TextInputFieldModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 10:16'!
initialize
	"Initialization code for TextComposableModel"

	super initialize.

	textHolder := '' asValueHolder.
	actionToPerformHolder := [:text | ] asValueHolder.
	
	ghostText := ''.
	acceptOnCR := true.
	autoAccept := false.! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 17:31'!
okToChange

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:45'!
removeEntryCompletion

	self entryCompletion: nil! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
setSelection: anInterval

	self morph setSelection: anInterval! !

!TextInputFieldModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
text: aText

	textHolder contents: aText! !

!TextInputFieldModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
textHolder

	^ textHolder! !

ComposableModel subclass: #TextModel
	instanceVariableNames: 'aboutToStyleHolder behaviorHolder textHolder actionToPerformHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!TextModel commentStamp: '<historical>' prior: 0!
A TextComposableModel is an applicative model which handle a basic text.

| t |
t:= TextComposableModel new.
t openWithSpec.
t textHolder contents: 'This is a test'.

self example!

!TextModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/4/2012 14:46'!
example
	| instance |
	
	instance := self new.
	instance openWithSpec.
	instance text: 'This is a test'.! !

!TextModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/23/2012 19:14'!
internSpec

	^ {#PluggableTextMorph.
	    		#on:text:accept:readSelection:menu:. 	#model. #getText. #accept:. nil. nil.
			#hResizing:. 							#spaceFill.
			#vResizing:. 							#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}}! !

!TextModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/13/2011 23:31'!
title

	^ 'Text'! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 22:59'!
aboutToStyle: aBoolean	

	aboutToStyleHolder contents: [ aBoolean ]! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 22:58'!
aboutToStyleBlock: aBlockReturningABoolean	

	aboutToStyleHolder contents: aBlockReturningABoolean! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 00:06'!
aboutToStyleHolder

	^ aboutToStyleHolder! !

!TextModel methodsFor: 'morphic' stamp: 'SimonAllier 1/27/2012 11:50'!
accept: aText

	self textHolder contents: aText.
	self actionToPerformHolder contents cull: aText.
	self changed: #clearUserEdits.! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 14:36'!
action: aBlockWithOneArgument

	actionToPerformHolder contents: aBlockWithOneArgument! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 00:08'!
actionToPerformHolder

	^ actionToPerformHolder! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/16/2012 02:15'!
behavior: aText

	behaviorHolder contents: aText! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
behaviorHolder

	^ behaviorHolder! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:17'!
doItContext

	^ nil! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:17'!
doItReceiver

	^ self selectedBehavior
		ifNil: [ nil ]
		ifNotNil: [:class | class theNonMetaClass ]! !

!TextModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForNextFocus

	^ '<Ctrl-Cmd-right>'! !

!TextModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:55'!
eventStringForPreviousFocus

	^ '<Ctrl-Cmd-left>'! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 17:26'!
getText
	
	^ self textHolder contents! !

!TextModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:16'!
initialize
	"Initialization code for TextComposableModel"

	super initialize.

	textHolder := '' asValueHolder.
	behaviorHolder := nil asValueHolder.
	aboutToStyleHolder := [ false ] asValueHolder.
	actionToPerformHolder := [:text | ] asValueHolder.
	textHolder whenChangedDo: [ self changed: #getText ].
	aboutToStyleHolder whenChangedDo: [ self changed: #getText ].
	behaviorHolder whenChangedDo: [:class |
		self morph ifNotNil: [:mrph | mrph classOrMetaClass: class ].
		self changed: #getText ].! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 17:30'!
okToChange

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:09'!
okToStyle

	^ true! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:14'!
selectedBehavior

	^ self behaviorHolder contents! !

!TextModel methodsFor: 'protocol' stamp: 'SimonAllier 1/24/2012 16:58'!
setSelection: anInterval

	self morph setSelection: anInterval! !

!TextModel methodsFor: 'morphic' stamp: 'BenjaminVanRyseghem 12/14/2011 14:21'!
shoutAboutToStyle: aMorph
	
	^ self aboutToStyleHolder contents value! !

!TextModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/15/2012 23:26'!
text: aText

	textHolder contents: aText! !

!TextModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
textHolder

	^ textHolder! !

Object subclass: #DropListItem
	instanceVariableNames: 'actionHolder label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!DropListItem commentStamp: '<historical>' prior: 0!
A DropListItem is an item (wrapper) designed to fit into a DropList!

!DropListItem class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/2/2012 15:17'!
example

	| b |
	b:= DropListModel new.
	b openWithSpec.
	b items: { 	DropListItem named: 'label 1' do: [:label | label inspect ].
				DropListItem named: 'label 2' do: [:label | label inspect ].
				DropListItem named: 'label 3' do: [:label | label inspect ].
				DropListItem named: 'label 4' do: [:label | label inspect ]}.

	b whenSelectedItemChanges: [:item | item inspect ]! !

!DropListItem class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/2/2012 14:51'!
named: label do: aBlock

	^ self new
		action: aBlock;
		label: label;
		yourself! !

!DropListItem methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 14:51'!
action: aBlock

	self actionHolder contents: aBlock! !

!DropListItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 14:43'!
actionHolder
	
	^ actionHolder! !

!DropListItem methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 14:50'!
initialize
	"Initialization code for DropListItem"

	super initialize.

	actionHolder := [] asValueHolder.
	label := ''.! !

!DropListItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 14:43'!
label
	
	^ label! !

!DropListItem methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 14:43'!
label: anObject
	
	label := anObject! !

!DropListItem methodsFor: 'execution' stamp: 'BenjaminVanRyseghem 2/2/2012 14:52'!
value
	"This way, I am polymorphic with nil"

	self actionHolder contents cull: self label cull: self! !

Object subclass: #MorphWrapper
	instanceVariableNames: 'layout morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!MorphWrapper commentStamp: '<historical>' prior: 0!
A MorphWrapper is used to wrap a morph with a layout in the goal to be easily added to another morph!

!MorphWrapper class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: morph layout: layout 

	^ self new
		layout: layout;
		morph: morph;
		yourself! !

!MorphWrapper methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 11/14/2011 16:31'!
addIn: aContainer

	aContainer
		addMorph: morph
		fullFrame: layout! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
frame: relFrame
	| frame |
	frame := LayoutFrame new.
	frame 
		leftFraction: relFrame left; 
		rightFraction: relFrame right; 
		topFraction: relFrame top; 
		bottomFraction: relFrame bottom.
	layout := frame! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
fullFrame: anObject
	
	layout := anObject! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: anObject
	
	morph := anObject! !

Object subclass: #NewValueHolder
	instanceVariableNames: 'announcer contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!NewValueHolder commentStamp: '<historical>' prior: 0!
A NewValueHolder is a new implementation of ValueHolder based on Announcements!

NewValueHolder subclass: #ComposableValueHolder
	instanceVariableNames: 'block originalValueHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ComposableValueHolder commentStamp: '<historical>' prior: 0!
A ComposableValueHolder is a value holder based on another value holder which content is calculated regarding the original value holder content!

!ComposableValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
on: originalValueHolder do: block

	^ self new
		block: block;
		originalValueHolder: originalValueHolder;
		yourself! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block

	^ block! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block: anObject
	
	block := anObject! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
originalValueHolder

	^ originalValueHolder! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
originalValueHolder: aValueHolder
	
	originalValueHolder := aValueHolder.
	aValueHolder whenChangedSend: #updateContents to: self.
	self update: #update! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:57'!
updateContents

	| args |
	args := self originalValueHolder contents.
	args isArray
		ifTrue: [ self contents: (self block valueWithArguments: args)]
		ifFalse: [ self contents: (self block value: args)].! !

NewValueHolder subclass: #DictionaryValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
at: anObject

	^ contents at: anObject! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:12'!
at: key ifAbsentPut: aBlock 

	contents at: key ifAbsentPut: aBlock.
	self contentsChanged
	! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:12'!
at: key put: value

	contents at: key put: value.
	self contentsChanged
	! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:12'!
atNewIndex: index put: anObject
	
	contents atNewIndex: index put: anObject.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/9/2012 16:56'!
contents

	self error: 'The contents should be accessed directly or you could break the mechanism of events'.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:12'!
doesNotUnderstand: aMessage

	^ (contents respondsTo: aMessage selector)
		ifTrue: [ contents perform: aMessage selector withEnoughArguments: aMessage arguments ]
		ifFalse: [ super doesNotUnderstand: aMessage ]! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 16:31'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection keysAndValuesDo: [ :key :value |
		self at: key put: (aBlock value: value) ]! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/9/2012 16:26'!
initialize
	"Initialization code for DictionaryValueHolder"

	super initialize.
	self contents: Dictionary new.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
initialize: n
	
	contents initialize: n.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
removeAll
	
	contents removeAll.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 16:34'!
removeKey: key 
	"Remove key from the receiver.
	If key is not in the receiver, notify an error."
	
	^ self removeKey: key ifAbsent: [self errorKeyNotFound: key].! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
removeKey: key ifAbsent: aBlock 
	| result |
	
	result := contents removeKey: key ifAbsent: aBlock.
	self contentsChanged.
	^ result! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
size 

	^ contents size! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary 
	
	contents valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary.
	self contentsChanged.! !

!NewValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:28'!
contents: contents

	^ self new
		contents: contents;
		yourself! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 11/28/2011 09:31'!
addDependent: aDependent

	self halt: 'Former API, should be changed'.! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:23'!
contents

	^ contents! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:35'!
contents: anObject
	
	| oldValue |
	oldValue := contents.
	contents := anObject.
	self contentsChanged: oldValue.! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:24'!
contentsChanged
	
	announcer announce: (ValueChanged newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:24'!
contentsChanged: oldValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 01:10'!
initialize

	super initialize.
	
	announcer := Announcer new! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 2/9/2012 16:54'!
whenChangedDo: aBlock

	| block |
	block := [ aBlock cull: contents ].
	announcer on: ValueChanged do: block! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
whenChangedSend: aSelector to: aReceiver

	announcer on: ValueChanged send: aSelector to: aReceiver! !

NewValueHolder subclass: #SelectionValueHolder
	instanceVariableNames: 'index selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!SelectionValueHolder commentStamp: '<historical>' prior: 0!
A SelectionValueHolder is a value holder especially designed to contains a list selection (an index + an object)!

!SelectionValueHolder class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 21:00'!
index: indexValueHolder selection: selectionValueHolder

	^ self new
		index: indexValueHolder;
		selection: selectionValueHolder;
		yourself! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:09'!
contents

	^ {index. selection}! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
index

	^ index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:59'!
index: anIndex

	index := anIndex.
	self changed: #index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
initialize

	super initialize.
	index := 0 asValueHolder.
	selection := nil asValueHolder.
	
	index whenChangedSend: #contentsChanged to: self.
	selection whenChangedSend: #contentsChanged to: self.! !

!SelectionValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:58'!
reset

	self index contents: 0.
	self selection contents: nil.
	self contentsChanged! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
selection

	^ selection! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:58'!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !

!Object methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/28/2011 09:29'!
asValueHolder

	^ NewValueHolder contents: self! !

Object subclass: #RadioButtonGroup
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!RadioButtonGroup commentStamp: '<historical>' prior: 0!
A RadioButtonGroup is a group for radio buttons which ensure that only radio button of this group is activated at the same time.!

!RadioButtonGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:02'!
addRadioButton: aButton

	buttons do: [:b | 
		aButton whenActivatedDo: [ b privateSetState: false ].
		b whenActivatedDo: [ aButton privateSetState: false ]].
		
	buttons add: aButton.
	aButton privateSetState: false! !

!RadioButtonGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:03'!
default: aButton

	aButton privateSetState: true.
	aButton takeKeyboardFocus.! !

!RadioButtonGroup methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/1/2012 17:35'!
initialize
	"Initialization code for RadioButtonGroup"

	super initialize.

	buttons := OrderedCollection new.! !

Object subclass: #SpecInterpreter
	instanceVariableNames: 'instance bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

SpecInterpreter class
	instanceVariableNames: 'Bindings'!

!SpecInterpreter commentStamp: '<historical>' prior: 0!
#model is a magic world to swap the symbol to the model object
!

SpecInterpreter class
	instanceVariableNames: 'Bindings'!

!SpecInterpreter class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:33'!
bindings

	^ Bindings ifNil: [ self initializeBindings. ^ Bindings ]! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:39'!
buildMorphFor: aComposableModel
	
	^ self new buildMorphFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:40'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self new buildMorphFor: aComposableModel withSpec: aSymbol! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:40'!
buildWindowFor: aComposableModel
	
	^ self new buildWindowFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/30/2012 17:02'!
initialize

	super initialize.
	
	SystemBrowser registeredClasses do:[:each | each addGroupForPackage: self package ]! !

!SpecInterpreter class methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 14:29'!
initializeBindings

	Bindings := Dictionary new.

	Bindings
		at: #List put: #PluggableListMorph;
		at: #Text put: #PluggableTextMorph;
		at: #Button put: #PluggableButtonMorph;
		at: #Panel put: #PanelMorph;
		at: #Checkbox put: #CheckboxMorph;
		at: #DropList put: #DropListMorph;
		at: #TextField put: #PluggableTextFieldMorph! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:36'!
interpretASpec: aSpec model: aModel
	
	^ self new	interpretASpec: aSpec model: aModel! !

!SpecInterpreter class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:34'!
resetBindings

	Bindings := nil! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
bindings
	
	^ bindings! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 1/19/2012 17:19'!
buildMorphFor: aComposableModel
	
	^ self buildMorphFor: aComposableModel withSpec: #internSpec! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 1/19/2012 17:19'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self interpretASpec: (aComposableModel class perform: aSymbol) model: aComposableModel! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 1/19/2012 16:38'!
buildWindowFor: aComposableModel
	
	^ self interpretASpec: aComposableModel class windowSpec model: aComposableModel! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
classKeys

	^ Smalltalk keys, self bindings keys! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
convertSymbolOfClassToInstance: aSymbol

	| symbol |
	symbol := self bindings at: aSymbol ifAbsent: [ aSymbol ].

	^ (Smalltalk at: symbol) new! !

!SpecInterpreter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
initialize
	"Initialization code for SpecInterpreter"

	super initialize.

	bindings := self class bindings.
	instance := nil.! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:25'!
instance

	^ instance! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:25'!
instance: anObject
	
	instance := anObject! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 2/4/2012 11:35'!
interpretASpec: aSpec model: aModel
	| index |

	aSpec ifNil: [ ^ nil ].
	(aSpec isCollection and: [aSpec isSequenceable]) ifFalse: [ ^ aSpec ].
	(aSpec isString or: [ aSpec isText ]) ifTrue: [ 
			^ aSpec == #model
				ifTrue: [ aModel ]
				ifFalse: [ 
					(self classKeys identityIncludes: aSpec)
						ifTrue: [ self convertSymbolOfClassToInstance: aSpec ]
						ifFalse: [ aSpec ]]].

	" aSpec is an Array "
	instance := self class interpretASpec: aSpec first model: aModel.
	index := 2.	
	
	[ index <= aSpec size ]
		whileTrue: [ | selector numArgs args newInstance result |
			selector := aSpec at: index.
			numArgs := selector numArgs.
			args := aSpec copyFrom: index + 1 to: index + numArgs.
			args := args collect: [:each | self class interpretASpec: each model: aModel].
			index := index + numArgs + 1.
			newInstance := instance perform: selector withArguments: args.
			index > aSpec size
				ifTrue: [
					aModel morph: instance.
					^ self interpretASpec: newInstance model: instance ].
			instance := newInstance].
	"If you get here, there is a problem. Must probably it comes from the Spec which is wrongly defined"
	self assert: false.
	^ instance! !

Object subclass: #TabClassical
	instanceVariableNames: 'container tab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!TabClassical commentStamp: '<historical>' prior: 0!
A TabClassical is an example to learn how to use tabs ;)!

!TabClassical class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/5/2012 18:33'!
associations: associations

	^ self new
		addTabs: associations;
		yourself.! !

!TabClassical class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 1/5/2012 18:39'!
example

	| tc testMorph model anotherMorph associations |
	
	model := ClassMethodBrowser new.
	
	testMorph := model buildWithSpec: #internSpec.
	anotherMorph := model buildWithSpec: #internSpec2.
	
	associations := {'Test' -> testMorph. 'Another'-> anotherMorph}.
	tc := self associations: associations.
	
	model listHolder contents: (Smalltalk allClasses).
	tc open.! !

!TabClassical methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/7/2012 05:59'!
addAll: window
	
	window
		addMorph: tab
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ 35)).
				
	window
		addMorph: container
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 35 corner: 0 @ 0)).
				
	tab tabs size = 0 ifTrue: [ ^ self ].
	tab color: Color white darker darker! !

!TabClassical methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/15/2012 22:13'!
addTabs: associations

	associations do: [:each |
		self tab 
			addTab: (Text fromString: each key) 
			withAction: [ 	self setMorph: each value ].
		container submorphs isEmpty ifTrue: [ container addMorph: each value ]]! !

!TabClassical methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/5/2012 18:30'!
initialize
	"Initialization code for TabClassical"

	super initialize.

	container := PanelMorph new changeTableLayout; listDirection: #bottomToTop; color: Color white; yourself.
	tab := PluggableTabBarMorph on: self.
	tab width: 150.! !

!TabClassical methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/5/2012 18:21'!
open

	| window panel |
	window := StandardWindow new.
	panel := PanelMorph new hResizing: #spaceFill; vResizing: #spaceFill; changeProportionalLayout.

	window addMorph: panel frame: (0@0 corner: 1@1).
	self addAll: panel.
	window openInWorld.
	
	window title: 'Tab Test'! !

!TabClassical methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/3/2012 18:59'!
setMorph: aMorph

	container removeAllMorphs.
	container addMorph: aMorph.
	aMorph color: Color white.
	aMorph takeKeyboardFocus.! !

!TabClassical methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/3/2012 19:02'!
tab

	^ tab! !
SpecInterpreter initialize!
